static char *cvs_id =" $Id: xnd_deb.c,v 1.2 2002/01/10 15:24:41 berar Exp $ ";
/* XND_DEB   debye factors and anharmonic exp  */
#include "../xnd_def.h"
#include "../xnd_cah.h"
/* ---------------------------------------------------------- */
/* thermal factors                                            */
/* debye_0 and debye_2 are used in incomensurate phases       */
/* ---------------------------------------------------------- */
float debye_0(P_(float) b_iso)
#ifdef NO_PROTO
float b_iso;
#endif
{  return exp( -0.25 * b_iso * q);
   }
/* ---------------------------------------------------------- */
/* input : h_sym, output : hk_sym, product for derivatives    */
/* ---------------------------------------------------------- */
float debye_2 (P_(float *) b_ij, P_(float *) h_sym, P_(float *) hk_sym)
#ifdef NO_PROTO
float *b_ij, *h_sym, *hk_sym;
#endif
{  hk_sym[0]= h_sym[0]*h_sym[0];
	hk_sym[1]= h_sym[1]*h_sym[1];
	hk_sym[2]= h_sym[2]*h_sym[2] ;
	hk_sym[3]= 2*h_sym[0]*h_sym[1];
	hk_sym[4]= 2*h_sym[0]*h_sym[2];
	hk_sym[5]= 2*h_sym[1]*h_sym[2];
	return exp(-(b_ij[0]*hk_sym[0]+b_ij[1]*hk_sym[1]+b_ij[2]*hk_sym[2]
              +b_ij[3]*hk_sym[3]+b_ij[4]*hk_sym[4]+b_ij[5]*hk_sym[5]));
  }
/* ---------------------------------------------------------- */
/* anharmonic tensors symetry expansion                       */
/* ---------------------------------------------------------- */
/* input : h_sym, output : hk_sym, product for derivatives    */
/* ---------------------------------------------------------- */
float anharm_3 (P_(float *) b_c, P_(float *) h_sym, P_(float *) hk_c)
#ifdef NO_PROTO
float *b_c, *h_sym, *hk_c;
#endif
{  int j;
   float anharm = 0;
   hk_c[0]= h_sym[0]*h_sym[0]*h_sym[0];
	hk_c[1]= h_sym[1]*h_sym[1]*h_sym[3];
	hk_c[2]= h_sym[2]*h_sym[2]*h_sym[2];
	hk_c[3]= h_sym[0]*h_sym[0]*h_sym[1];
	hk_c[4]= h_sym[0]*h_sym[0]*h_sym[2];
	hk_c[5]= h_sym[1]*h_sym[1]*h_sym[0];
	hk_c[6]= h_sym[1]*h_sym[1]*h_sym[2];
	hk_c[7]= h_sym[2]*h_sym[2]*h_sym[0];
	hk_c[8]= h_sym[2]*h_sym[2]*h_sym[1];
	for(j=0;j<COORD_ANHARM3;j++) anharm += b_c[j]*hk_c[j];
	return anharm;
	}
/* ---------------------------------------------------------- */
float anharm_4 (P_(float *) b_d, P_(float *) h_sym, P_(float *) hk_d)
#ifdef NO_PROTO
float *b_d, *h_sym, *hk_d;
#endif
{  int j;
   float anharm = 0;
   hk_d[0]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0];
	hk_d[1]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1];
	hk_d[2]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2];
	hk_d[3]= h_sym[0]*h_sym[0]*h_sym[2]*h_sym[2]/2;
	hk_d[4]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[1]/2;
	hk_d[5]= h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2]/2;
	hk_d[6]= h_sym[1]*h_sym[1]*h_sym[0]*h_sym[2]/2;
	hk_d[7]= h_sym[2]*h_sym[2]*h_sym[0]*h_sym[1]/2;
	hk_d[8]= h_sym[2]*h_sym[2]*h_sym[0]*h_sym[2]/2;
	hk_d[9]= h_sym[0]*h_sym[0]*h_sym[1]*h_sym[1];
	hk_d[10]= h_sym[0]*h_sym[0]*h_sym[2]*h_sym[2];
	hk_d[11]= h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2];
	hk_d[12]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[2]/2;
	hk_d[13]= h_sym[1]*h_sym[1]*h_sym[0]*h_sym[1]/2;
	hk_d[14]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]/2;
	for(j=0;j<COORD_ANHARM4;j++) anharm += b_d[j]*hk_d[j];
	return anharm;
	}
/* ---------------------------------------------------------- */
float anharm_5 (P_(float *) b_e, P_(float *) h_sym, P_(float *) hk_e)
#ifdef NO_PROTO
float *b_e, *h_sym, *hk_e;
#endif
{  int j;
   float anharm = 0;
   hk_e[0]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0];
	hk_e[1]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1];
	hk_e[2]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2];
	hk_e[3]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[1];
	hk_e[4]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[2];
	hk_e[5]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[0];
	hk_e[6]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[2];
	hk_e[7]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[0];
	hk_e[8]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[1];
	hk_e[9]= h_sym[0]*h_sym[0]*h_sym[1]*h_sym[1]*h_sym[0];
	hk_e[10]= h_sym[0]*h_sym[0]*h_sym[2]*h_sym[2]*h_sym[0];
	hk_e[11]= h_sym[1]*h_sym[1]*h_sym[0]*h_sym[0]*h_sym[1];
	hk_e[12]= h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2]*h_sym[1];
	hk_e[13]= h_sym[2]*h_sym[2]*h_sym[0]*h_sym[0]*h_sym[2];
	hk_e[14]= h_sym[2]*h_sym[2]*h_sym[1]*h_sym[1]*h_sym[2];
	hk_e[15]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[2]*h_sym[0]/2;
	hk_e[16]= h_sym[1]*h_sym[1]*h_sym[0]*h_sym[1]*h_sym[1]/2;
	hk_e[17]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]/2;
	hk_e[18]= h_sym[0]*h_sym[0]*h_sym[1]*h_sym[1]*h_sym[2];
	hk_e[19]= h_sym[0]*h_sym[0]*h_sym[2]*h_sym[2]*h_sym[1];
	hk_e[20]= h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2]*h_sym[0];
	for(j=0;j<COORD_ANHARM5;j++) anharm += b_e[j]*hk_e[j];
	return anharm;
	}
/* ---------------------------------------------------------- */
float anharm_6 (P_(float *) b_f, P_(float *) h_sym, P_(float *) hk_f)
#ifdef NO_PROTO
float *b_f, *h_sym, *hk_f;
#endif
{  int j;
   float anharm = 0;
   hk_f[0]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0];
	hk_f[1]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1];
	hk_f[2]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2];
	hk_f[3]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[1]/2;
	hk_f[4]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[2]/2;
	hk_f[5]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[0]*h_sym[1]/2;
	hk_f[6]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[2]/2;
	hk_f[7]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[0]*h_sym[2]/2;
	hk_f[8]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[1]*h_sym[2]/2;
	hk_f[9]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[1]*h_sym[1];
	hk_f[10]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[2]*h_sym[2];
	hk_f[11]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[0]*h_sym[0];
	hk_f[12]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2];
	hk_f[13]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[0]*h_sym[0];
   hk_f[14]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[1]*h_sym[1];
	hk_f[15]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[0]*h_sym[1]*h_sym[2]/2;
   hk_f[16]= h_sym[1]*h_sym[1]*h_sym[1]*h_sym[1]*h_sym[0]*h_sym[2]/2;
   hk_f[17]= h_sym[2]*h_sym[2]*h_sym[2]*h_sym[2]*h_sym[0]*h_sym[1]/2;
   hk_f[18]= h_sym[0]*h_sym[1]*h_sym[0]*h_sym[1]*h_sym[0]*h_sym[1]/8;
   hk_f[19]= h_sym[0]*h_sym[2]*h_sym[0]*h_sym[2]*h_sym[0]*h_sym[2]/8;
   hk_f[20]= h_sym[1]*h_sym[2]*h_sym[1]*h_sym[2]*h_sym[1]*h_sym[2]/8;
   hk_f[21]= h_sym[0]*h_sym[0]*h_sym[2]*h_sym[2]*h_sym[0]*h_sym[2]/2;
   hk_f[22]= h_sym[0]*h_sym[0]*h_sym[0]*h_sym[1]*h_sym[0]*h_sym[1]/2;
   hk_f[23]= h_sym[1]*h_sym[1]*h_sym[0]*h_sym[0]*h_sym[1]*h_sym[2]/2;
   hk_f[24]= h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2]*h_sym[0]*h_sym[1]/2;
   hk_f[25]= h_sym[2]*h_sym[2]*h_sym[0]*h_sym[0]*h_sym[1]*h_sym[2]/2;
   hk_f[26]= h_sym[2]*h_sym[2]*h_sym[1]*h_sym[1]*h_sym[0]*h_sym[2]/2;
   hk_f[27]= h_sym[0]*h_sym[0]*h_sym[1]*h_sym[1]*h_sym[2]*h_sym[2];
	for(j=0;j<COORD_ANHARM6;j++) anharm += b_f[j]*hk_f[j];
	return anharm;
	}
 /* ---------------------------------------------------------- */


