static char *cvs_id =" $Id: xnd_hkl.c,v 1.3 2002/06/19 09:57:10 berar Exp $ ";
/* XND_HKL    F_hkl, generate HKL... */
/* the fhkl_atom function here defined is used only by simple phases */
#define USE_RBRG
#define USE_BRAGG
#define USE_VAR
#define USE_SETS
#define USE_SYM
#define USE_MODUL
#define USE_EXPER
#define USE_ATOM
#define USE_PHASE
#define USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include <string.h>
/* ---------------------------------------------------------- */
/* procedure for calculation of structure factor for          */
/* standart phases                                            */
/* the argument pos is the starting position to use in the    */
/* derivatives tables                                         */
/* it return the number of atomic parameters and              */
/* modify the values of F_A and F_B (if necesary fano...      */                       
/* ---------------------------------------------------------- */
int  fhkl_atom (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{
    int   i,j,is, ic,nb,ianharm;
    float x,y,z,f;
    float hk[3];
    float hk_b[6], bb[6];
    float hk_c[COORD_ANHARM3], cc[COORD_ANHARM3];
    float hk_d[COORD_ANHARM4], dd[COORD_ANHARM4];
    float hk_e[COORD_ANHARM5], ee[COORD_ANHARM5];
    float hk_f[COORD_ANHARM6], ff[COORD_ANHARM6];
    float *l_coef;
    float fm, fbm;
    double trans, taux;
    double phi, debye, radius;
    double anharm[2], anharm3, anharm4, anharm5, anharm6;
    double d_ab[2], cs_phi[2];
    double ab[2]= {0,0};

   nb = l_atom->nb;
   var_init(l_atom->x);
   x = var_valeur (0);
   y = var_valeur (1);
   z = var_valeur (2);
   taux = var_valeur (3);
   if ((l_atom->nature & B_ANISO) == 0)
   {  debye = debye_0( var_valeur (4));
      if ((l_atom->nature & F_ROTAT)) radius = q * var_valeur(5);
      ianharm=5;
      }
   else
   {  for (i=0;i<6;i++)  bb[i] = var_valeur (4+i);
      ianharm=10;
      }
   if (l_atom->n_anharm)
   {  var_init(l_atom->anharm);
      if (l_atom->nature & B_ANHARM3) 
      {  nb += COORD_ANHARM3;
         for (i=0;i<COORD_ANHARM3;i++) cc[i] = var_valeur (i);
	      }
      if (l_atom->nature & B_ANHARM4) 
      {  nb += COORD_ANHARM4;
         for (i=0;i<COORD_ANHARM4;i++) dd[i] = var_valeur (i);
	      }
      if (l_atom->nature & B_ANHARM5) 
      {  nb += COORD_ANHARM5;
         for (i=0;i<COORD_ANHARM5;i++) ee[i] = var_valeur (i);
	      }
      if (l_atom->nature & B_ANHARM6) 
      {  nb += COORD_ANHARM6;
         for (i=0;i<COORD_ANHARM6;i++) ff[i] = var_valeur (i);
	      }
      }
   if (deriv_atom) for (ic=0;ic<dim_centro;ic++) 
      for (j=0;j<nb;j++)  fab_deriv[ic][pos+j] = 0;

   for (is=0,l_coef=current_symgrp->coef;is<current_symgrp->nops;is++,l_coef+=12)
   {  hk[0] = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
      hk[1] = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
      hk[2] = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
      trans = H * l_coef[9] + K * l_coef[10] + L * l_coef[11];
      phi = 2 * M_PI * (hk[0] * x + hk[1] * y + hk[2] * z + trans);
      if (l_atom->nature & B_ANISO) debye = debye_2(bb, hk, hk_b);
      cs_phi[0] = cos(phi) * debye;
      cs_phi[1] = sin(phi) * debye;
      if (l_atom->n_anharm) 
      {  anharm3 = anharm4 = anharm5 = anharm6 = 0;
         if (l_atom->nature & B_ANHARM3) anharm3 = anharm_3(cc, hk, hk_c);
         if (l_atom->nature & B_ANHARM4) anharm4 = anharm_4(dd, hk, hk_d);
         if (l_atom->nature & B_ANHARM5) anharm5 = anharm_5(cc, hk, hk_e);
         if (l_atom->nature & B_ANHARM6) anharm6 = anharm_6(ff, hk, hk_f);
	      anharm[0] = 1 + anharm4 + anharm6;
	      anharm[1] = anharm3 + anharm5;
	      cs_phi[0] = cs_phi[0]*anharm[0] - cs_phi[1]*anharm[1];
         cs_phi[1] = cs_phi[1]*anharm[0] + cs_phi[1]*anharm[1];
         }  /*  anharm  */
     ab[0] += cs_phi[0];
     if (!centro)  ab[1] += cs_phi[1];
     if (deriv_atom)
     {  d_ab[0] = -2 * M_PI * cs_phi[1];
        if (!centro)  d_ab[1] =  2 * M_PI * cs_phi[0];
        for (ic=0;ic<dim_centro;ic++) 
	{  for(j=0;j<3;j++)
	      fab_deriv[ic][pos+j] += hk[j] * d_ab[ic];
           if (l_atom->nature & B_ANISO) for(j=0;j<6;j++)
              fab_deriv[ic][pos+4+j] -= hk_b[j] * cs_phi[ic];
           if (l_atom->n_anharm)   /* this approx avoid zero div */
	      if (l_atom->nature & B_ANHARM3) for(j=0;j<COORD_ANHARM3;j++)
              fab_deriv[ic][pos+ianharm+j] += hk_c[j] * cs_phi[ic] / anharm[0];
	      if (l_atom->nature & B_ANHARM4) for(j=0;j<COORD_ANHARM4;j++)
              fab_deriv[ic][pos+ianharm+j] += hk_d[j] * cs_phi[ic] / anharm[0];
	      if (l_atom->nature & B_ANHARM5) for(j=0;j<COORD_ANHARM5;j++)
              fab_deriv[ic][pos+ianharm+j] += hk_e[j] * cs_phi[ic] / anharm[0];
	      if (l_atom->nature & B_ANHARM6) for(j=0;j<COORD_ANHARM6;j++)
              fab_deriv[ic][pos+ianharm+j] += hk_f[j] * cs_phi[ic] / anharm[0];
           } 
         }  /* if (deriv_atom) */
       }    /* for current_symgrp->coef */
    f = (*valdif)();
    /* si diffusion anomale on traite a part la contrib imaginaire de f */
    if (dif_nature == EXPER_RXA)  f += anodif();
    fm = f * fhkl_mult * taux;
	 /* this is to allow free rotator */
	 if (l_atom->nature & F_ROTAT && radius > EPSILON ) fm *= sin(radius)/radius;
    F_A += fm * ab[0];
    if (!centro)  F_B += fm * ab[1];
    if (dif_nature == EXPER_RXA)
    {  fbm = fhkl_mult * taux * anodif_b();
       for (ic=0;ic<dim_centro;ic++) act->f_abm[ic] += fbm * ab[ic] ;
       }
    if (deriv_atom==0) return (0);
    for (ic=0;ic<dim_centro;ic++) 
    {  for (j=0;j<3;j++)  fab_deriv[ic][pos+j] *= fm;
       fab_deriv[ic][pos+3] = f * fhkl_mult * ab[ic];
       if ((l_atom->nature & B_ANISO)==0) 
       {   fab_deriv[ic][pos+4] = -0.25 * q * ab[ic] * fm; 
           for (j=5;j<nb;j++)  fab_deriv[ic][pos+j] *= fm;
	        if (l_atom->nature & F_ROTAT && radius > EPSILON ) 
			       fab_deriv[ic][pos+5] *=  q*(1/tan(radius)-1/radius)/fm;
	        }
       else for (j=4;j<nb;j++) fab_deriv[ic][pos+j] *= fm;
       if (dif_nature == EXPER_RXA)
         for (j=0;j<nb;j++) fabm_deriv[ic][pos+j] = fab_deriv[ic][pos+j] * fbm/fm;
       }
    return (nb);
    }

 /* ---------------------------------------------------------- */
float  cell_fsum (P_(void))
{  int i,j;
   int pos=0;

   push_err_msg("fhkl(xnd_hkl.c)");
   temp = &temp_phase;
   F_A = F_B = act->f_abm[0] = act->f_abm[1] = 0;
   if ( l_phase->nb_atom == 0 ) F_A = 1;
   for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
      pos +=  (*fhkl_eff) (pos);
   for (j=0;j<l_phase->nb_bloc;j++)
      for (i=0,l_atom=l_phase->bl_relat[j];i<l_phase->bl_atom[j];i++,l_atom++)
         pos += (*fhkl_eff) (pos);
   fhkl_2 = F_A * F_A + F_B * F_B;
     /* anomal sur poudre , moyenne sur hkl et -hkl */
   if (dif_nature && EXPER_RXA) 
      fhkl_2 += act->f_abm[0]*act->f_abm[0]+act->f_abm[1]*act->f_abm[1];
   pop_err_msg();
   return (fhkl_2);
   }

 /* ---------------------------------------------------------- */
void hkl_std(P_(void))
{    h_eff = H;
     k_eff = K;
     l_eff = L;
     }
 /* ---------------------------------------------------------- */
 /* ---------------------------------------------------------- */
#ifdef OS_CHECK_ABORT
#ifdef MAC_OS
#include <Events.h>
void chk_for_abort(P_(void))
{    EventRecord  event;    /* pour intercepter Pomme . */
/*  if ( GetNextEvent(KeyDownMask, event) ) return 1;  */
      return ;
     }
#endif      
#ifdef MS_DOS
#include <conio.h>
void chk_for_abort(P_(void))
{   if (kbhit())   getch();    /* pour une gestion du Controle_C */
    } 
#endif
#ifdef __WIN32__
// #include <conio.h>
void chk_for_abort(P_(void))
{   //if (kbhit())   getch();    /* pour une gestion du Controle_C */
    } 
#endif
#endif
/* ---------------------------------------------------------- */
/* allowed hkl lines return 0, others 1; used to skip lines   */
int prohibed(void)
{  if ( (*extinction)() != 0 ) return 1;
   if (l_pseudo_phase->sets && sets_extinction(l_pseudo_phase->sets)!= 0 ) return 1;
   return 0;
	}
/* ---------------------------------------------------------- */
/* the following redirected functions return intensity        */
static float (*get_intensity)(int ihkl);
/* ---------------------------------------------------------- */
float get_hkl_intensity(int ihkl)
{   act->mu = (*multiplicity)();
    orientation();
    return  act->mu * act->cor * act->orien * (*fhkl_sum)();
    }
/* ---------------------------------------------------------- */
float get_line_intensity(int ihkl)
{   act->mu = -1;
    orientation();
    var_init(current_sets->intensity);
    i_intens = ihkl;
    return act->orien * var_valeur(ihkl-1);
    }
/* ---------------------------------------------------------- */
float get_para_intensity(int ihkl)
{   act->mu = -1;
    act->orien = 1;
    var_init(current_sets->intensity);
    i_intens = ihkl;
    return var_valeur(2*ihkl-1);
    }
/* ---------------------------------------------------------- */
#define ALLOC_NONE_NB 20
int auto_intensity = 0;
static alloc_lines;
float get_none_intensity(int ihkl)
{  float intens;
   sint * hkl;
   int j;
   push_err_msg("get_none_intensity");
   orientation(); 
   act->mu = - (intens = (*multiplicity)());
	intens *= act->cor;
   i_intens = t_bragg;
   if (alloc_lines >= 0)
	{   if (t_bragg > alloc_lines )
       {  alloc_lines +=  ALLOC_NONE_NB;
		    var_alloc(alloc_lines, VAR_HKL);
	       }
       ihkl = t_bragg -1;
       hkl = (sint *)var_get_link(current_sets->intensity);
       for (j=0; j<l_phase->hkl_size;j++)
	    {  hkl[ihkl*l_phase->hkl_size+j]=act->h[j];
          }
       var_set_value( current_sets->intensity, ihkl, intens);
	    if (current_sets->auto_intensity==1) auto_intensity++;
		 }
    pop_err_msg();
	 return intens * act->orien;
    }
/* ---------------------------------------------------------- */
static void valid_hkl(P_(int) ihkl)
{    push_err_msg("valid_hkl valid");
     t_bragg++;
     act->dist = 1/s;
     sin2_t=sin_t*sin_t;
     cos_t = sqrt (1-sin2_t);
     tan_t = sin_t / cos_t;
     tan2  = tan_t * tan_t;
     sin_2t = 2 * sin_t * cos_t;
     cos2_2t = 1-sin_2t*sin_2t;
     cos_2t =  sqrt (cos2_2t);
     if ( tan_t > 1 ) cos_2t *= -1.0;
     cotan_2t =  cos_2t / sin_2t;
     DTH += zero;
	  switch(l_exper->techn%4)
	  {  case 3 : DTH += centrage * sin_2t; break; /* curved detector */
		  default : DTH += centrage * sin_2t; break; 
		  } 
     valcor();
     act->ech = echelle * exp ( -0.25 * bg * q);
     I_C = act->ech * (*get_intensity)(ihkl);
     *(d_echelle+1) = -0.25 * q ;
     if (I_C>EPSILON)
     {   traite_hkl();
         if (fini && prt_hkl & 128)
         {  int jj;
            fprintf (list_fich, "   (%d)%3d%3d%3d",act->phase,H,K,L);
            for(jj=0;jj<prt_modsize;jj++)
            fprintf (list_fich,"%3d", act->h[jj+3]);
            fprintf (list_fich,
 " (%d) %7.3f %6.1f (%6.1f %6.1f)  %d %6.1g traitee\n",
      act->lambda,DTH,I_C,F_A,F_B, act->mu, act->cor);
             }
     if (i_intens==0 && l_phase->uncoherent & DIF_TDS_HKL )   gen_tds_hkl();
       }
     else if (fini && prt_hkl & 4)  fprintf (list_fich,
 "   (%d)%3d%3d%3d (%d) %7.3f %6.1f (%6.1f %6.1f)  %d %6.1g nulle\n",
      act->phase,H,K,L,act->lambda,DTH,I_C,F_A,F_B, act->mu, act->cor);
     pop_err_msg();
     }
 /* ---------------------------------------------------------- */
int exist_hkl (P_(int) ihkl)
#ifdef NO_PROTO
int ihkl;
#endif
{   static char exist_msg[30];
    sprintf(exist_msg,"exist_hkl (%d) %d %d %d", act->phase, H, K, L);
    push_err_msg(exist_msg);
#ifdef OS_CHECK_ABORT
    chk_for_abort();
#endif
    switch (l_phase->nature)
    { case PHASE_QUASI : 
          h_eff = H + K * M_GOLD;
          l_eff = L;
          q = g_aa * h_eff + g_bb * l_eff;
          break;
       case PHASE_PARASITE : var_init(current_sets->intensity);
          q = 1/var_valeur(2*(ihkl-1));
          q *= q;
			 H = ihkl;
          break;
       default :
          if (l_phase->vector == NULL)
          {  if (( H==0 && K==0 && L==0 ) || prohibed()!=0)
			         {  pop_err_msg();  return(0);  }   }
          else if ((H==0 && K==0 && L==0 && act->h[3]==0) || prohibed()!=0)
			         {  pop_err_msg();  return(0);  }
          (*hkl_eff)();
          q = h_eff * ( h_eff * g_aa + k_eff * g_ab + l_eff * g_ac);
          q += k_eff * ( k_eff * g_bb + l_eff * g_bc ) + l_eff * l_eff * g_cc;
          }
     if (q<q_min || q>q_max) {    pop_err_msg(); return (0); }
     s=sqrt(q);
     DTH=2/RAD * asin((double) (sin_t=0.5*s*lambda));
     if (DTH<t_min || DTH>t_max) { pop_err_msg(); return (0); }
     valid_hkl(ihkl);
     pop_err_msg();
     return (1);
     }
 /* ---------------------------------------------------------- */
 /* H, K, L are fixed, generates -H, -K, L lines if needed     */
void gen_sym_related (void)
{  if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
   if (systeme=='T')
   {   if (K!=0 || L!=0)
       {   H = -H;
           if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
           H = -H;
           }
       if (K!=0 && K!=H && L!=0)
       {   K = -K;
           if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
           K = -K;
           }
       if (L!=0 && L!=K)
       {   L = -L;
           if (exist_hkl(0) && !current_symgrp->holoedre) gen_holoedre ();
           L = -L;
       }   }
   if (systeme=='R' && (L!=0 && ( H!=0 || K!=0) ))
   {   L = -L;
       if (exist_hkl(0) && !current_symgrp->holoedre)
       gen_holoedre ();
       L = -L;
       }
    }
/* ---------------------------------------------------------- */
void gen_hkl (P_(void))
{   int    k_min, k_max;
     int    h_min, h_max;
     float  sol_k, sol_h;
     float  val, val_kl, val_kk, val_ko;
     float  val_a, val_b, val_c;

    push_err_msg("gen_hkl(xnd_hkl.c)");
     val_b = sqr (g_bc - 0.5 * g_ab * g_ac / g_aa);
     val_a = 4 * (g_bb - 0.5 * g_ab * g_ab / g_aa);
     val_c = g_cc - 0.5 * g_ac * g_ac / g_aa;
     L = 0;
     val_ko = val_a * q_max;
     val_kk= val_b - val_a * val_c;
     if (val_kk < 0) val_kk = - val_kk;    /* metriques tres tordues */
     do
     {   sol_k= val_ko - L*L* val_kk;
         if (sol_k>0)
         {   sol_k = sqrt(sol_k)/2 / g_bb;
          val   = -L * g_bc / (2 * g_bb);
          k_max = ceil (val+sol_k);
          if ((systeme=='A' || systeme=='L') && L != 0) k_min = floor(val-sol_k);
          else if (systeme=='C' || systeme=='T') k_min = L;
          else k_min = 0;
          for (K=k_min;K<=k_max;K++)
          {   sol_k = (L*L) * g_cc + (K*K) * g_bb + (K*L) * g_bc;
               val_kl = L * g_ac + K * g_ab;
               sol_h = sqr (val_kl) - 4 * g_aa *  (sol_k -q_max);
               if (sol_h>0)
               {   sol_h = sqrt(sol_h) / (2 * g_aa);
                   val = -val_kl / (2 * g_aa);
                   h_max = ceil (val+sol_h);
                   if ( (systeme=='M' && L!=0) || (systeme=='N' &&  K!=0)
                    ||  (systeme=='A' && (L!=0 || K!=0)))
                    h_min = floor(val-sol_h);
                   else if (systeme=='C'|| systeme=='R' || systeme=='T'
                    || systeme=='Q' || systeme=='H')
                    h_min = K;
                   else h_min = 0;
                   for (H=h_min;H<=h_max;H++) gen_sym_related();
               }         /* if sol_h */
             }    /* for k */
          }       /* if sol_k */
          L++;
      } while (sol_k >= 0);
     pop_err_msg();
     }
 /* ---------------------------------------------------------- */
void get_hkl (P_(void))
{   int    i, j;
    sint  *l_hkl;
    l_hkl = (sint *) var_get_link (current_sets->intensity);
    for (i=0;i<current_sets->nb_hkl;i++,l_hkl+=l_phase->hkl_size)
     {    if (l_phase->nature != PHASE_PARASITE)
            for (j=0; j<l_phase->hkl_size;j++)
			     act->h[j] = l_hkl[j];
           else H = K = L = 0;
			 exist_hkl (i+1);
          }
     }
/* ---------------------------------------------------------- */
void make_hkl (P_(int) iphase)
{  int ic;
   push_err_msg("make_hkl(xnd_hkl.c)");
   current_symgrp = l_pseudo_phase->symgrp;
   var_init(l_phase->cell);
   if (l_phase->nature != PHASE_PARASITE) centrage = var_valeur (0);
   else centrage = 0;
   if (current_symgrp != NULL)
   {  systeme = current_symgrp->systeme;
      centro  = current_symgrp->centro;
	   dim_centro = centro ? 1 : 2;
      }
	act = default_bragg;
	memset( act, 0, sizeof(TYPE_BRAGG));
	act->phase = iphase;
	current_satel = l_pseudo_phase->satel;
   current_modul = l_pseudo_phase->modul;
   fhkl_eff = l_pseudo_phase->fhkl_eff;
   fhkl_sum = l_pseudo_phase->cell_fhkl;
   hkl_eff    = l_pseudo_phase->hkl_eff;
   gen_holoedre = l_pseudo_phase->gen_holoedre;
   genget_hkl   = l_pseudo_phase->genget_hkl;
   multiplicity = l_pseudo_phase->multiplicity;
   extinction = l_pseudo_phase->extinction;
   fhkl_mult  =   l_pseudo_phase->fhkl_mult;
   current_sets = l_pseudo_phase->sets;
   i_intens =  0;
   if (l_phase->n_atom) get_intensity = get_hkl_intensity ;
	else if (l_phase->nature == PHASE_PARASITE) get_intensity =  get_para_intensity;
	else if (current_sets->intensity  && current_sets->intensity->order != 0)
         get_intensity = get_line_intensity;
   else  
	{   get_intensity = get_none_intensity;
       var_alloc(ALLOC_NONE_NB , VAR_HKL);
       alloc_lines =ALLOC_NONE_NB;
		}
   if (l_phase->n_orien)
   {  orien_val = (float *) tst_alloc(ORIEN*l_phase->n_orien,sizeof(float),"orien");
      ini_orientation();
      }
   else orien_val = NULL;
   if (l_phase->n_prof)
   {  orien_prof = (float *) tst_alloc(ORIEN_PROF*l_phase->n_prof,sizeof(float),"orien");
      if (l_pseudo_phase->sets && l_phase->m_prof) l_phase->prof=current_sets->prof;
      var_init(l_phase->prof);
		}
	else orien_prof = NULL;
   if (l_phase->nb_bloc) ini_blk( fini && minli==0 );
                
   if ((minli==0 && fini==0) && l_phase->nb_par)
   {  deriv_atom=l_phase->nb_par;
      if (deriv_atom) for (ic=0;ic<dim_centro;ic++) 
      {  fab_deriv[ic] = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
         if (dif_nature==EXPER_RXA)
             fabm_deriv[ic] = (float *) tst_alloc (deriv_atom,sizeof(float),"deriv");
         }
      }
   else deriv_atom = 0;
   temp = &temp_exper;

   t_min = (diag_p0+zero+centrage) * 0.98 - 1.0;
   if (t_min<0) t_min =0;
   t_max = (diag_pn+zero+centrage) * 1.02 + 1.0;
   if (t_max>180) t_max =180;

   for (act->lambda=0;act->lambda<l_exper->n_lambda;act->lambda++)
   {  var_init (l_onde);
      lambda = var_valeur (act->lambda * LAMBDA);
      if (dif_nature == EXPER_RXA) ini_anodif();
      exper_echelle = var_valeur (act->lambda*LAMBDA + 1);
      echelle = phase_echelle * exper_echelle;
      q_min=sqr(2*sin(0.5*RAD*t_min)/lambda);
      q_max=sqr(2*sin(0.5*RAD*t_max)/lambda);
      (*genget_hkl)();   
      if ( alloc_lines > 0 && get_intensity == get_none_intensity )
      {   alloc_lines = -t_bragg;
          }
      }
   if ( alloc_lines < 0)
   {   current_sets->nb_hkl = -alloc_lines;
       var_adjust(current_sets->intensity, -alloc_lines);
       alloc_lines = 0;
       }
   if (deriv_atom) for (ic=0;ic<dim_centro;ic++) 
   {  free (fab_deriv[ic]);
      if (dif_nature==EXPER_RXA)  free (fabm_deriv[ic]);
      }
   if (l_phase->nb_bloc) free_blk();
   if (orien_val) free (orien_val);
   if (orien_prof) free (orien_prof);
   if (minli==0) fprintf(list_fich," %d hkl (%d non nuls, %d generes)\n",m_bragg,n_bragg,t_bragg);
   pop_err_msg();
   }
 /* ---------------------------------------------------------- */



