static char *cvs_id =" $Id: xnd_mag.c,v 1.2 2002/01/10 15:24:42 berar Exp $ ";
/* XND_MAG.C   traitements specif des struct magnetiques */

#define USE_BRAGG
#define USE_SETS
#define USE_VAR
#define USE_SYM
#define USE_MODUL
#define USE_ATOM
#define USE_PHASE
#define USE_PSEUDO
#include "../xnd_def.h"
#include "../xnd_cah.h"
#include <string.h>
static dbg = 0;
#define DBG_MSG 2
/* ---------------------------------------------------------- */
static int atom_magnet=0;
static int cur_atom;
static float *nucl_coef=NULL;
static float vFab[2][3];         /* components of the magn struct factor */
static float *atom_vFab[2][3];   /* atomic components in previous */
static float *vFab_deriv[2][3];  /* deriv of atomic components */
static float fa2[2],sin2_a[2];
TYPE_SYMGRP * nucl_symgrp=NULL;
/* ---------------------------------------------------------- */
/* vector structure factor associated with a magnetic atom */
static int  fhkl_magnet (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{  int   i,j,is, ii,ic,id,nb,imag;
   float x,y,z,f;
   float mx[3], rmx[3], nx,ny,nz;
   float hk[3];
   float hk_b[6], bb[6];
   float *l_coef, *m_coef;
   float fm, fbm;
   double trans, taux;
   double phi, debye;
   double d_ab[2], cs_phi[2];
   double v_ab[3][2]= {{0,0},{0,0},{0,0}};
   
   nb = l_atom->nb;
   for (ic=0;ic<dim_centro;ic++) for( id=0;id<3;id++)
   {  atom_vFab[ic][id][cur_atom] = 0;
      if (deriv_atom) for (j=0;j<nb;j++) vFab_deriv[ic][id][pos+j] = 0;
      }
   if (l_atom->mdif==NULL) return nb;
	push_err_msg("fhkl_magnet");
   var_init (l_atom->x);
   x = var_valeur (0);
   y = var_valeur (1);
   z = var_valeur (2);
   taux = var_valeur (3) / current_modul->size; 
   if ((l_atom->nature & B_ANISO) == 0)
   {   debye = debye_0( var_valeur (4));
       imag=5;
       }
   else
   {   for (i=0;i<6;i++)  bb[i] = var_valeur (4+i);
       imag=10;
       }
   for (id=0;id<3;id++) mx[id] = var_valeur (imag+id);
   for (is=0,m_coef=current_symgrp->coef;is<current_symgrp->nops;is++,m_coef+=12)
   {  l_coef=nucl_sym(is,current_symgrp);
       hk[0] = l_coef[0] * H + l_coef[1] * K + l_coef[2] * L;
       hk[1] = l_coef[3] * H + l_coef[4] * K + l_coef[5] * L;
       hk[2] = l_coef[6] * H + l_coef[7] * K + l_coef[8] * L;
       trans = H * l_coef[9] + K * l_coef[10] + L * l_coef[11];
       /* first the phase of the structure factor */  
       phi = 2 * M_PI * (hk[0] * x + hk[1] * y + hk[2] * z + trans);
       if (l_atom->nature & B_ANISO) debye = debye_2(bb, hk, hk_b);
       cs_phi[0] = cos(phi) * debye;
       cs_phi[1] = sin(phi) * debye;
       /* now calc the magnetic contribution to the scatering factor */  
       for( id=ii=0;id<3;id++,ii+=3)
		    rmx[id] = m_coef[ii]*mx[0] + m_coef[ii+1]*mx[1] + m_coef[ii+2]*mx[2];
       for (ic=0;ic<dim_centro;ic++) for( id=0;id<3;id++)
          v_ab[ic][id] += rmx[id] * cs_phi[ic];
       if (deriv_atom)
       {  d_ab[0] = -2 * M_PI * cs_phi[1];
          if (!centro)  d_ab[1] =  2 * M_PI * cs_phi[0];
          for (ic=0;ic<dim_centro;ic++) for( id=0;id<3;id++)
	       {  for(j=0;j<3;j++)
	           vFab_deriv[ic][id][pos+j] += hk[j] * d_ab[ic]* rmx[id];
             if (l_atom->nature & B_ANISO) for(j=0;j<6;j++)
              vFab_deriv[ic][id][pos+4+j] -= hk_b[j] * cs_phi[ic]*rmx[id];
             for(j=0;j<3;j++)
	           vFab_deriv[ic][id][pos+imag+j] += cs_phi[ic]* m_coef[j+3*id];
             }
           }  /* if (deriv_atom) */
        }    /* for current_symgrp->coef */
    f = 0.2695 * mb_valdif();  /* barn conversion */
    fm = f * fhkl_mult * taux;
    for (ic=0;ic<dim_centro;ic++) for(id=0;id<3;id++)
      vFab[ic][id] += atom_vFab[ic][id][cur_atom] = fm * v_ab[ic][id];
    if (deriv_atom==0) {   pop_err_msg(); return (0); }
    for (ic=0;ic<dim_centro;ic++) for(id=0;id<3;id++)
    {  for (j=0;j<3;j++)  vFab_deriv[ic][id][pos+j] *= fm;
       vFab_deriv[ic][id][pos+3] = f * fhkl_mult * v_ab[ic][id];
       if ((l_atom->nature & B_ANISO)==0) 
       {   vFab_deriv[ic][id][pos+4] = -0.25 * q * atom_vFab[ic][id][cur_atom];
           for (j=5;j<nb;j++)  vFab_deriv[ic][id][pos+j] *= fm;
	       }
       else for (j=4;j<nb;j++) vFab_deriv[ic][id][pos+j] *= fm;
       }
   pop_err_msg();
    return (nb);
    }
/* ---------------------------------------------------------- */
/* transform vector deriv to scalar ones needed in xnd_der.c */
/* this neglect the derivative part of sin_2a */
static int  fmag_deriv (P_(int) pos)
#ifdef NO_PROTO
int pos;
#endif
{  int   i,j,is, ii,ic,id,nb;
   
   nb = l_atom->nb;
   for (ic=0;ic<dim_centro;ic++) for (j=0;j<nb;j++)  
	  fab_deriv[ic][pos+j] = 0;
   if (l_atom->mdif==NULL) return nb;
   if (deriv_atom==0) return (0);
   for (ic=0;ic<dim_centro;ic++) if (act->f_ab[ic] > EPSILON)
   {  for (j=0;j<nb;j++)
      {  for( id=0;id<3;id++)
           fab_deriv[ic][pos+j] += vFab[ic][id] * vFab_deriv[ic][id][pos+j];
         fab_deriv[ic][pos+j] /= act->f_ab[ic];
         }
      }
   return (nb);
   }
/* ---------------------------------------------------------- */
/* For a magnetic phase  F(Q)^2 is calculated using the general
/* expresion of Halpern and Johnson:
/*       F(Q)^2 = { Fm(Q)^2 - (e.Fm(Q)^2 } = Fm(Q)^2 sin(a)^2
/* where Fm(Q) is the vector of the magnetic structure factor
/* and e is the unit vector along the scattering vector Q
/* At the time no average on equivalent reflction is done
/* it then on the responsability of user to specify a
/* suitable bravais lattice
/* ---------------------------------------------------------- */
float  cell_fmag (P_(void))
{  int i,j,ib,ic,id;
   int pos=0;
   float scal;
   push_err_msg("cell_fmag(xnd_mag.c)");
	if (atom_magnet==0 || atom_magnet<l_phase->n_atom)
	{  atom_magnet=l_phase->n_atom;
	   for (ic=0;ic<dim_centro;ic++) for( id=0;id<3;id++)
      atom_vFab[ic][id]=(float *)tst_alloc(atom_magnet,sizeof(float),"magnetic structure factor");
	   if (deriv_atom) for (ic=0;ic<dim_centro;ic++) for( id=0;id<3;id++)
      vFab_deriv[ic][id]=(float *)tst_alloc(deriv_atom,sizeof(float),"magnetic structure factor derivatives");
		}
   temp = &temp_phase;
   if ( dbg++ < DBG_MSG) verbose_printf( "\n Fhkl_Magnet. %s(%s) (%d %d %d) ... DO NOT USE, procedure without symmetry\n",
    nucl_symgrp->nom, current_symgrp->nom, H, K, L);
	F_A = F_B = act->f_abm[0] = act->f_abm[1] = 0;
   if ( l_phase->nb_atom == 0 ) { F_A = 1; return 1;}
   for (ic=0;ic<dim_centro;ic++) for( id=0;id<3;id++) vFab[ic][id] = 0;
   for (i=0,l_atom=l_phase->atom;i<l_phase->n_atom;i++,l_atom++)
   {  cur_atom = i;
		pos +=  (*fhkl_eff) (pos);
		}
/*   for (ib=0;ib<l_phase->nb_bloc;j++)   check alloc before using it
      for (i=0,l_atom=l_phase->bl_relat[ib];i<l_phase->bl_atom[ib];i++,l_atom++)
         pos += (*fhkl_eff) (pos);      */
   for (ic=0;ic<dim_centro;ic++)
   {  fa2[ic] = vFab[ic][0]*vFab[ic][0]+vFab[ic][1]*vFab[ic][1]+vFab[ic][2]*vFab[ic][2];
      scal = x_orien*vFab[ic][1] + y_orien*vFab[ic][1] + z_orien*vFab[ic][2];
	   act->f_ab[ic] = sqrt(  fa2[ic] - scal*scal + EPSILON) ;
      if ( fa2[ic] > EPSILON ) sin2_a[ic] =  1.0 - scal*scal/fa2[ic];
      else  sin2_a[ic] = 0;
      }
   fhkl_2 = F_A * F_A + F_B * F_B;

   if ( dbg < DBG_MSG && cycle == 0 ) verbose_printf( " Fm (%.2f %.2f %.2f)-> norm = %.2f\n",
    vFab[0][0], vFab[0][1], vFab[0][2], F_A );
   /* the practical values of derivatives have now to be calculated */
   if (deriv_atom)
   {  pos = 0;
      for (cur_atom=0,l_atom=l_phase->atom;cur_atom<l_phase->n_atom;cur_atom++,l_atom++)
        pos +=  fmag_deriv (pos);
		}
   pop_err_msg();
   return (fhkl_2);
   }

/* ---------------------------------------------------------- */
int ini_pseudo_mag (P_(TYPE_PSEUDO *) l_pseudo_phase, P_(int *)is_magnet)
{   char txt[80];
    TYPE_SETS *l_sets = l_pseudo_phase->sets;
	 *is_magnet = 0;
    if (l_sets->loop_str == NULL || l_sets->loop_str[0]==0) return 0;
    if (strstr(l_sets->loop_str,"MAGNET")==NULL) return 0;
    if (nucl_coef==NULL) nucl_coef=(float*) malloc(12*sizeof(float));
    current_modul = l_phase->magnet;
    l_pseudo_phase->genget_hkl = genget_mag;
    l_pseudo_phase->modul = current_modul;
    l_pseudo_phase->txt = str_alloc("Magnetic structure");
    l_pseudo_phase->ps_case = PS_MAGNET;
	 l_pseudo_phase->cell_fhkl = cell_fmag;
    l_pseudo_phase->fhkl_eff = fhkl_magnet;
    current_symgrp = l_pseudo_phase->symgrp = current_modul->symgrp;
	 /*  symmetry according magnetic group */
    l_pseudo_phase->fhkl_mult = ini_3D_fhkl_mult(current_symgrp);
    l_pseudo_phase->extinction   = ini_3D_extinction( current_symgrp);
    l_pseudo_phase->multiplicity = ini_3D_multiplicity(current_symgrp); 
    l_pseudo_phase->gen_holoedre = ini_3D_gen_holoedre(current_symgrp);
	 return 0;
    }
/* ---------------------------------------------------------- */
float *nucl_sym (P_(int) nmag, P_(TYPE_SYMGRP *) m_symgrp)
#ifdef NO_PROTO
int nmag;
TYPE_SYMGRP * m_symgrp;
#endif
{   int i, j;
    float *l_coef;
    if (nucl_coef==NULL) nucl_coef=(float*) malloc(12*sizeof(float));

    j = nmag % nucl_symgrp->nops;
    l_coef = nucl_symgrp->coef + j * nucl_symgrp->size;
    for (i=0;i<nucl_symgrp->size;i++) nucl_coef[i]=l_coef[i];
    j = nmag / nucl_symgrp->nops;
    if ( j == 0) return nucl_coef;
    if ( nucl_symgrp->centro == 1 && m_symgrp->centro == 0 )
    {   if ( j % 2 == 1 )  for (i=0;i<nucl_symgrp->size;i++) nucl_coef[i]*=-1;
        j /= 2;
        if ( j == 0) return nucl_coef;
	}
    if ( (nucl_symgrp->bravais == 'A'|| nucl_symgrp->bravais == 'F')
         &&  (nucl_symgrp->bravais != 'A'|| nucl_symgrp->bravais != 'F'))
    {   if ( j % 2 == 1 ) { nucl_coef[10]+=0.5;  nucl_coef[11]+=0.5; }
        j /= 2;
        if ( j == 0) return nucl_coef;
	}
    if ( (nucl_symgrp->bravais == 'B'|| nucl_symgrp->bravais == 'F')
         &&  (nucl_symgrp->bravais != 'B'|| nucl_symgrp->bravais != 'F'))
    {   if ( j % 2 == 1 ) { nucl_coef[9]+=0.5;  nucl_coef[11]+=0.5; }
        j /= 2;
        if ( j == 0) return nucl_coef;
	}
    if ( (nucl_symgrp->bravais == 'C'|| nucl_symgrp->bravais == 'F')
         &&  (nucl_symgrp->bravais != 'C'|| nucl_symgrp->bravais != 'F'))
    {   if ( j % 2 == 1 ) { nucl_coef[9]+=0.5;  nucl_coef[10]+=0.5; }
        j /= 2;
        if ( j == 0) return nucl_coef;
	}
/*  l_phase->magnet n est pas connu dans read
    if (l_phase->magnet->superstruct[0] != 0) nucl_coef[9] += j;
    if (l_phase->magnet->superstruct[1] != 0) nucl_coef[10] += j;
    if (l_phase->magnet->superstruct[2] != 0) nucl_coef[11] += j;
*/
    tst_abort((1),"\n Unexpected symmetry case in generating nuclear ops\n");
    return nucl_coef;
    }
/* ---------------------------------------------------------- */
