static char *cvs_id =" $Id: xnd_pro.c,v 1.4 2002/07/09 06:27:11 berar Exp $ ";
/* XND_PRO.C     main procedure for profile functions */
/*               they are now in xnd_pr??.c files     */
#define USE_BRAGG
#define USE_VAR
#define USE_PHASE
#define USE_EXPER
#define EXTERN_PROF
#include "xnd_prof.h"

/* =========================================================== */
/* define the line profile and initialize the profil functions */
/* ----------------------------------------------------------- */
int def_profil (P_(void))
{  int i, j;
   float v, w;
   float val;
   temp = &temp_exper;
   var_init (l_onde);
   val = var_valeur (act->lambda*LAMBDA+2);
   sign_onde = val >= 0 ? 1 : -1;
   W_L = fabs ( val * (tan_t-tan_tm));
   W_G = sqr (var_valeur (act->lambda*LAMBDA+3) * (tan_t-tan_tm));
   if (var_init (l_instru))
   {  val = var_valeur( 2 );
      sign_instru2 = val >= 0 ? 1 : -1;
      W_L +=  fabs( val * cotan_2t );
      W_G +=  sqr (var_valeur (3) * cotan_2t);
      if (l_exper->techn %4 != 3)
      {  val = var_valeur( 0 );
         sign_instru0 = val >= 0 ? 1 : -1;
         W_L += fabs( val );
         W_G +=  sqr (var_valeur (1));
         }
      else
      {   dpro_asym = sqrt(sin(RAD*(DTH-t_asym)));
          sign_instru0 = 1;
          W_L += var_valeur(0)+var_valeur(4)*dpro_asym +var_valeur(6)*dpro_asym*dpro_asym;
          W_G += sqr (var_valeur (1)) + sqr (var_valeur (5)*dpro_asym) 
             + sqr (var_valeur (7)*dpro_asym*dpro_asym);
/* verbose_printf("xnd_pro t_asym %.2f   dpro... %.3f\n",t_asym,dpro_asym);*/
         }
         
		}
   for (i=0; i<max_asym;i++) act->asym[i]  = 0;
   /* instrumental asym can use convolution, xnd 1.17 */ 
   if ( asym_mode != 0) 
   {  if (var_init (l_asym))
      {  for (i=j=0; i<max_asym;i++,j+=ASYM)
           act->asym[i]  = var_valeur (j) * cotan_2t + var_valeur (1+j) / tan_t
             + var_valeur (2+j) * sin_2t;
         }  } 
     temp = &temp_phase;
     /* new def in 1.07 : the unique width of a phase depends on the direction */
     phase_wg = phase_wl = 0;
     var_init (l_phase->prof);
     for (i=0;i<l_phase->n_prof;i++)
     {   val = f_orien(i,1);       /* stores also values in orien_prof[0..2] */
         orien_prof[i*ORIEN_PROF+3]=orien_prof[i*ORIEN_PROF+4]=0;
         if ((v= var_valeur (i*PROF))!=0) 
         {   phase_wl += w = val * v / cos_t;
             orien_prof[i*ORIEN_PROF+3] += w;
             }
         if ((v= var_valeur (1+i*PROF)) !=0)   /* must be != and not > error in 1.20 */
         {   phase_wg += w = val * v / cos_t;
             orien_prof[i*ORIEN_PROF+4] += w;
             }
         if ((v= var_valeur (2+i*PROF))!=0)
         {   phase_wl += w =val * v * tan_t;
             orien_prof[i*ORIEN_PROF+3] += w;
             }
         if ((v= var_valeur (3+i*PROF)) !=0)
         {   phase_wg += w =val * v * tan_t;
             orien_prof[i*ORIEN_PROF+4] += w;
             }
         }
     W_L += fabs( phase_wl );
     sign_phase = phase_wl >= 0 ? 1 : -1;
     W_G += sqr( phase_wg );
     if ( W_L < 0 ) W_L = 0;
     if ( W_G > 0 ) W_G = sqrt (W_G); else W_G = 0;
     /* new def in 1.08 : asym no more in width block */
	  /* angular dependence corrected in 1.20 */
     for (i=0;i<l_phase->n_prof;i++)
     {   var_init (l_phase->prof);
         val = f_orien(i,1);
         var_init (l_phase->asym);
         for (j=0;j<max_asym;j++)
         {   orien_prof[i*ORIEN_PROF+5+j]=0;
             if ((v= var_valeur (j*(PASYM+i*max_asym)))!=0)
             {    act->asym[j] += w = v * val ;
                 orien_prof[i*ORIEN_PROF+5+j] += w;
                 }
             if ((v= var_valeur (1+j*(PASYM+i*max_asym)))!=0)
             {   act->asym[j] += w = v * val * tan_t;
                 orien_prof[i*ORIEN_PROF+5+j] += w;
                 }
        }
		}
    return (1);
    }
/* -------------------------------------------------------- */
int ini_profil (P_(void))
{   int ret_code;
    w_asym = W_G + W_L;
    x_coef = y_coef = 0;
    prof_case = 0;
    if (W_L<EPSILON)
    {   if (W_G > EPSILON)     ret_code = ini_gauss ();
           else return (0);
        }
    else if (W_G < EPSILON)    ret_code = ini_lorentz ();
    else if (voigt_mode)       ret_code = ini_voigt ();
    else                       ret_code = ini_psvoigt ();
    if (asym_mode == ASYM_CONVOL_ISNUM && ret_code) return def_asym();
    else return ret_code;
    }

/* -------------------------------------------------------- */
float profil (P_(void))
{  float valeur;
   switch ( asym_mode ) 
   {   case  ASYM_NO_CONVOL : 
         switch (prof_case)
         {  case  1 : valeur = gauss_profil   (); break;
            case  2 : valeur = lorentz_profil (); break;
            case  3 : valeur = psvoigt_profil (); break;
            case  4 : valeur = voigt_profil   (); break;
            default : return 0;
            }
         return (valeur * (*f_asym)());
       case  ASYM_CONVOL_KNOWN : 
         switch (prof_case)
         {  case  1 : valeur = a_gauss_profil   (); break;
            case  2 : valeur = a_lorentz_profil (); break;
            case  3 : valeur = a_psvoigt_profil (); break;
            default : return 0;
            }
         return (valeur * (*f_asym)());
       default : return (*profil_asym)();  
		 } 
    }
/* ----------------------------------------------------------- */
void d_pil   ( P_(void))
{  int i;
   switch ( asym_mode ) 
   {  case  ASYM_NO_CONVOL : 
      switch (prof_case)
      {   case 0 : d_p_t = d_p_g= d_p_l= 0;
             break;
          case 1 : d_p_t = gauss_dprof_dt() * as_coef - w_x * as_deriv; 
             d_p_g = gauss_dprof_dg() * as_coef;
             d_p_l = 0;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = w_x * as_d[i];
             break;
          case 2 : d_p_t = lorentz_dprof_dt() * as_coef - w_y * as_deriv;
             d_p_l = lorentz_dprof_dl() * as_coef;
             d_p_g = 0;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = w_y * as_d[i];
             break;
          case 3 : d_p_t = psvoigt_dprof_dt()* as_coef-(w_x+w_y)*as_deriv;
             d_p_g = psvoigt_dprof_dg() * as_coef;
             d_p_l = psvoigt_dprof_dl() * as_coef;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = (w_x+w_y) * as_d[i];
             break;
          case 4 : d_p_t = voigt_dprof_dt() * as_coef - w_x * as_deriv;
             d_p_g = voigt_dprof_dg() * as_coef;
             d_p_l = voigt_dprof_dl() * as_coef;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = w_x * as_d[i];
             break;
          }  break;
       case ASYM_CONVOL_KNOWN : 
       switch (prof_case)
       {  case 0 : d_p_t = d_p_g= d_p_l= 0;
             break;
          case 1 : d_p_t = a_gauss_dprof_dt() * as_coef - w_x * as_deriv; 
             d_p_g = a_gauss_dprof_dg() * as_coef;
             d_p_l = 0;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = w_x * as_d[i];
             break;
          case 2 : d_p_t = a_lorentz_dprof_dt() * as_coef - w_y * as_deriv;
             d_p_l = a_lorentz_dprof_dl() * as_coef;
             d_p_g = 0;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = w_y * as_d[i];
             break;
          case 3 : d_p_t = a_psvoigt_dprof_dt()* as_coef-(w_x+w_y)*as_deriv;
             d_p_g = a_psvoigt_dprof_dg() * as_coef;
             d_p_l = a_psvoigt_dprof_dl() * as_coef;
             for ( i = 0; i < max_asym ; i++) d_p_a[i] = (w_x+w_y) * as_d[i];
             break;
          }  break;
     default : (*d_pil_asym)(); 
	  } 
   }
/* ----------------------------------------------------------- */
void init_asym_function(P_(void))
{    
   fprintf (list_fich," The asymmetry functions code %d implies :\n", max_asym);
   if ( max_asym )
   {  if (max_asym<0)
      {  asym_mode = ASYM_CONVOL_ISNUM;
         max_asym = -max_asym;
         fprintf (list_fich,"        instrumental uses (H+S)/L ... convolution\n");
         fprintf (list_fich,"        together with odd derivative of gaussian\n");
         f_asym = asym_herm;
         if (voigt_mode) ini_asym_convol(); else  { asym_mode = ASYM_CONVOL_KNOWN; }
         }
      else
      {  asym_mode = ASYM_NO_CONVOL;
         fprintf (list_fich,"        instrument and phases use only odd power expansion with gaussian\n");
         f_asym = asym_herm;
/*       max_asym = -max_asym;
         f_asym = asym_power; */
         }
      tst_abort (( max_asym>MAX_ASYM), "too much asym functions required max(%d)", MAX_ASYM);
      }
   else
   {  asym_mode = ASYM_CONVOL_ISNUM;
         max_asym=2;
         fprintf (list_fich,"        instrumental uses only (H+S)/L ... convolution\n");
         fprintf (list_fich,"        phases uses only odd power expansion with gaussian\n");
/*         f_asym = asym_adj; */
            f_asym = asym_herm;
         if (voigt_mode) ini_asym_convol(); else  { asym_mode = ASYM_CONVOL_KNOWN; }
         }
    }
/* =========================================================== */


