static char *cvs_id =" $Id: xnd_rcry.c,v 1.2 2002/01/10 15:24:43 berar Exp $ ";
/* XND_RCRY.C     this file read all data except atoms for crystal phases */

#define USE_VAR
#define USE_KEYS
#define USE_SETS
#define USE_SYM
#define USE_MODUL
#define USE_ATOM
#define USE_PENAL
#define USE_PHASE
#include "../xnd_def.h"
#include "xnd_rdh.h"

void big_cell PROTO((int z_ratio, TYPE_SYMGRP *l_sym, TYPE_SYMGRP *l_sym4));  /* xnd_mod.c */
/* ------------------------------------------------------------------ */
extern TYPE_SYMGRP * nucl_symgrp;
static char   *txt_cell[CELL]   = {"Centr.","A","B","C","Alpha","Beta","Gamma"};
static char   *txt_orien[ORIEN]  = {"coef","theta","phi"};
static char   *txt_prof[PROF]   = {"Wl_C","Wg_C","WlT","WgT", "TETA","PHI"};
static char   *txt_pasym[PASYM] =  { "A0","AT"};
static char   *txt_bloc[BCOOR] =
                  { "X_Bl","Y_Bl","Z_Bl","TET","PHI","PSI"};
static char   *txt_dist[1]      =  { "Length" };
static char   *txt_angl[1]      =  { "Angle"};
static char   *txt_vector[VECTOR]   = {"d_a*","d_b*","d_c*"};
static char   *txt_dif[DIF]     = {"i", "wl"};
static char   *txt_tds[TDS]     = {"w_unc","tds_sp","tds_rd"};
/* ------------------------------------------------------------------ */
static int check_atom (P_(void))      /*  internal number of atom in bond */
{   char nom[10];
    char msg[100];
	 TYPE_ATOM *atom;
    int i,j,k;
    fscanf (coord_fich," %s",nom);
    fprintf (list_fich," %6s",nom);
    for (i=0,atom=l_phase->atom; i<l_phase->n_atom; i++,atom++)
        if (strcmp(nom, atom->nom)==0) return (i);
    for (k=0;k<l_phase->nb_bloc;k++)
    for (j=0,atom=l_phase->bl_ortho[k]; j<l_phase->bl_atom[k]; 
        j++,i++,atom++)
        if (strcmp(nom, atom->nom)==0) return (i);
    sprintf (msg, "unknown atom %s in bond lengths or angles!", nom);
	 termine (10, msg);
    return (0);
    }
/* ------------------------------------------------------------------ */
static TYPE_PENAL *fget_dist (P_(int) angle, P_(int) nb)
#ifdef NO_PROTO
int angle, nb;
#endif
{   TYPE_PENAL *p_dist,*p_0;
    TYPE_COORD *coord;
    char   nom[NAME_LG];
    int i,j,n;
    if (nb==0) return (NULL);
    l_atom = l_phase->atom;
    p_0 = p_dist =  (TYPE_PENAL *) tst_alloc(nb, sizeof(TYPE_PENAL), "dist");
    for (i=0;i<nb;i++,p_dist++)
    {     p_dist->remark  = read_remark(NULL);
              fscanf (coord_fich,"%d %f", &p_dist->nb_coord, &p_dist->sigma);
          fprintf (list_fich,"\n %d liaisons,  sigma = %.3f\n",
            p_dist->nb_coord, p_dist->sigma);
          p_dist->dist=fget_var (1,0,VAR_STD,angle==1 ? "LENGHT" : "ANGLE",
               (void *) txt_dist, NULL, NULL,0 ,0);
        coord = p_dist->coord = (TYPE_COORD *) tst_alloc(p_dist->nb_coord,
            sizeof(TYPE_COORD),"coord");
        for (j=0;j<p_dist->nb_coord;j++,coord++)
        {   fprintf(list_fich," #%2d ",j);
            coord->at0 = check_atom ();
            coord->endat = (ENDAT*) tst_alloc(angle,
            sizeof(ENDAT),"coord");
            for (n=0;n<angle;n++)
            {   fprintf (list_fich," -> ");
            coord->endat[n].at = check_atom ();
            fscanf (coord_fich," %[^;\n]%*[;\n]", nom);
            while (!analyse_xyz_pos(nom, coord->endat[n].coef, l_phase->symgrp, 3));
            fprint_xyz_pos (list_fich, coord->endat[n].coef,
                 (n == angle-1) ? '\n' : ' ');
            }
            }
        n_pen += p_dist->nb_coord ;
        }
    return (p_0);
    }
/* ------------------------------------------------------------------ */
void fget_phase_prof(P_(void))
{  int i,j, m_prof, r, n_sets;
   TYPE_SETS * l_sets;
	push_err_msg("fget_phase_prof(xnd_rcry.c)");
   m_prof = l_phase->n_prof;
	tst_abort(( m_prof < 0 && l_phase->nb_sets <= 1 ),"Unable to handle multiple profiles if (nb_sets <= 1)!");
	l_sets = l_phase->sets;
   if (m_prof < 0 )
	{  l_phase->n_prof= m_prof = - m_prof;
	   n_sets = l_phase->nb_sets;
		} 
	else n_sets = 0;
   if (m_prof)
   {  l_phase->remark_prof = read_remark(NULL);
      l_phase->c_prof = ( int *) tst_alloc (l_phase->n_prof,sizeof(int),"profil");
      for (j=0;j<m_prof;j++)
      {  fscanf(coord_fich,"%d",&l_phase->c_prof[j]);
         p_orien(j,1);
         }
      fprintf(list_fich,"\n");
      if (n_sets) 
		{  int par, mpar;
         fprintf(list_fich," n_prof<0, one block of profile parameters for each lines set\n");
         mpar = 0;
			for (r=0;r<n_sets;r++,l_sets++)
			{  char * pname;
			   par =0;
				pname = malloc(strlen(T_PROFIL)+3);
				sprintf(pname,"%s_%d",T_PROFIL , r);
			   l_sets->prof = fget_var(PROF*m_prof,PROF, VAR_ORIEN, pname, (void *)txt_prof, 
				NULL, NULL, VAR_MODE_GT0, 0);
				var_init(l_sets->prof);
            VAR_io_id  for (i=0;i<m_prof;i++) for(j=0;j<4;j++)
              if (var_param(i*PROF+j)) par++;
			   if (par > mpar) mpar = par;
				}
			phase_prof_par+= mpar;
			}
		else 
		{  l_sets->prof = l_phase->prof=fget_var(PROF*m_prof,PROF, VAR_ORIEN, T_PROFIL, (void *)txt_prof, 
		    NULL, NULL, VAR_MODE_GT0, 0);
         var_init(l_phase->prof);
         VAR_io_id
         for (i=0;i<m_prof;i++) for(j=0;j<4;j++)
           if (var_param(i*PROF+j)) phase_prof_par++;
			}
      fprintf(list_fich,"\n");
      l_phase->asym=fget_var(max_asym*PASYM*l_phase->n_prof,PASYM, VAR_ORIEN,
               T_PASYM, (void *)&txt_pasym[0], NULL, NULL, VAR_MODE_ABS, 0.5);
      var_init(l_phase->asym);
      VAR_io_id
      for (i=0;i<l_phase->n_prof;i++) for(j=0;j<max_asym*PASYM;j++)
         if (var_param(i*max_asym*PASYM+j)) phase_prof_par++;
      }
   pop_err_msg();
   }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void fget_phase_orien(P_(void))
{   int j;
     if (l_phase->nt_orien)
    {   l_phase->remark_orien = read_remark(NULL);
    l_phase->c_orien = ( int *) tst_alloc (l_phase->nt_orien, sizeof(int),"orien");
    for (j=0;j<l_phase->nt_orien;j++)
    {   fscanf(coord_fich,"%d",&l_phase->c_orien[j]);
        p_orien(j,0);
        }
    l_phase->orien=fget_var(ORIEN*l_phase->nt_orien,ORIEN, VAR_ORIEN,
               T_ORIEN, (void *)&txt_orien[0], NULL, NULL, 0, 0);
        }
     }
/* ------------------------------------------------------------------ */
static void fget_vector (P_(void ))
{  int size, smag = 0;
   int smod = 0;
   l_phase->vector = NULL;
   if (l_phase->magnet==NULL && l_phase->modul==NULL) return;
   if (l_phase->magnet && l_phase->magnet->order!=1)
       smag = l_phase->magnet->size;
   if (l_phase->modul && l_phase->modul->order!=1)
       smod = l_phase->modul->size;
   size = (smod >= smag) ? smod : smag;
   if (size == 0) return;
   push_err_msg("fget_vector");
   l_phase->vector=fget_var(size * VECTOR, VECTOR,
          VAR_STD, "VECTOR", (void *)txt_vector, NULL, NULL, 0 , 0 );
   if (current_modul && current_modul->compo_atom )
   {   var_init(l_phase->vector);
       tst_abort((var_valeur(0)!=0 || var_valeur(1)!=0 ),
         " composite superstructure can only deal with c superstruture\n");
       }
   pop_err_msg();
   return;
   }
/* ------------------------------------------------------------------ */
static TYPE_MODUL * fget_magnet (P_(void ))
{  char   name[NAME_LG];
   TYPE_MODUL *modul;
   TYPE_SYMGRP *m_symgrp;
   float  *m_coef;
   int i;

   push_err_msg("fget_magnet");
   modul = (TYPE_MODUL *) tst_alloc (1, sizeof(TYPE_MODUL), "modulation");
   modul->remark = read_remark(NULL);
	strcpy(name, "");
   tst_abort ((get_keys( "MAGNET", NULL,
        "ORDER",  KEYTYPE_INT, &(modul->order), (int) 1,
        "CENTER_X", KEYTYPE_FLOAT, &(modul->center_4d[0]), &(modul->center_4d[0]),
        "CENTER_Y", KEYTYPE_FLOAT, &(modul->center_4d[1]), &(modul->center_4d[1]),
        "CENTER_Z", KEYTYPE_FLOAT, &(modul->center_4d[2]), &(modul->center_4d[2]),
        "SYMGRP", KEYTYPE_CHAR, &(name), "",
			NULL) == -1), "key @MAGNET is necessary to read magnetic info\n");
   fprintf (list_fich,
   "\n MAGNETIC SUPERSTRUCTURE :  order (vector ratio) %d\n", modul->order);
   tst_abort ((modul->order<=0),"uncomensurated magnetic not implemented");
   fprintf(list_fich," symetry group for magnetic vectors: '%s'\n", name);
   m_symgrp = modul->symgrp = get_sym (name);
	current_symgrp = nucl_symgrp = l_phase->symgrp;
   fprintf(list_fich," Relation between nuclear (%s) and magnetic (%s) symmetries expressed on nuclear cell :\n",
	 current_symgrp->nom, m_symgrp->nom);
   for (i=0,m_coef=m_symgrp->coef; i<m_symgrp->nops; i++,m_coef+=m_symgrp->size)
   {   fprintf (list_fich," #%2d magnetic", i);
       fprint_xyz_pos (list_fich, m_coef, ' ');
       fprintf (list_fich," nuclear" );
       fprint_xyz_pos (list_fich, nucl_sym(i,m_symgrp), '\n');
       }
	current_symgrp = l_phase->symgrp;
   tst_abort( ((m_symgrp->nops%(current_symgrp->nops*modul->order)) != 0 ),
     "magnetic Nops must be multiple of nuclear Nops and superstructure order");
   modul->size =  (m_symgrp->nops / l_phase->symgrp->nops);
   fprintf(list_fich,"\n Symmetry ratio ( %d=%d*%d/%d) used for weighting included atoms\n", modul->size,
    modul->order ,m_symgrp->nops , current_symgrp->nops);
   tst_abort((l_phase->nb_sets<=0), "@CRYSTAL::SETS!=0 is requested");

  pop_err_msg();
  return modul;
  }
/* ------------------------------------------------------------------ */
static TYPE_MODUL *fget_modul (P_(void ))
{  char   name[NAME_LG], compo_symgrp[NAME_LG], compo_sym4grp[NAME_LG];

   push_err_msg("fget_modul");
   current_modul = (TYPE_MODUL *) tst_alloc (1, sizeof(TYPE_MODUL), "modulation");
   memset(current_modul, 0, sizeof(TYPE_MODUL));
   current_modul->remark = read_remark(NULL);
	current_modul->center_4d[0]=current_modul->center_4d[1]=current_modul->center_4d[2]=0.0;
   tst_abort ((get_keys ( "MODUL", NULL,
	   "SIZE", KEYTYPE_INT, &(current_modul->size), (int) 1,
	   "ORDER", KEYTYPE_INT, &(current_modul->order), (int) KEY_MODUL_ORDER,
      "CENTER_X", KEYTYPE_FLOAT, &(current_modul->center_4d[0]), &(current_modul->center_4d[0]),
      "CENTER_Y", KEYTYPE_FLOAT, &(current_modul->center_4d[1]), &(current_modul->center_4d[1]),
      "CENTER_Z", KEYTYPE_FLOAT, &(current_modul->center_4d[2]), &(current_modul->center_4d[2]),
      "SYMGRP", KEYTYPE_CHAR, &(name), "",
	   "COMPO", KEYTYPE_INT, &(current_modul->compo_atom), (int) 0,
      "COMPO_SYM", KEYTYPE_CHAR, &(compo_symgrp), "",
      "COMPO_SYM4", KEYTYPE_CHAR, &(compo_sym4grp), "",
	    "BIG_CELL", KEYTYPE_INT, &(current_modul->big_cell), 0,
			NULL) == -1), "key @MODUL is necessary to read modulation info\n");
	fprintf (list_fich,
   "\n MODULATION : %scommensurate, size %d\n",
   current_modul->order<=0?"un":"", current_modul->size);
/*   tst_abort ((current_modul->order>0),"commensurated modulation not implemented");
*/   tst_abort ((current_modul->size!=1)," only 4D groups are allowed : size ONE for modulation");
   l_phase->hkl_size = 3 + current_modul->size;
   if (current_modul->compo_atom )
   {   fprintf (list_fich, "composite structure :  the first %d atoms belong to the first layer, the %d=%d-%d others to the second\n",
            current_modul->compo_atom, l_phase->n_atom - current_modul->compo_atom, l_phase->n_atom , current_modul->compo_atom);
	    } else
   {   fprintf (list_fich, "0 : not a composite structure\n");
 	     }
   fprintf (list_fich,
      "\n 4d centering vector : %.4f  %.4f  %.4f\n", current_modul->center_4d[0],
            current_modul->center_4d[1], current_modul->center_4d[2]);
     if (current_modul->order <= 0)
     if (current_modul->order == -1)
	      fprintf (list_fich,"Structure factors use Bessel functions\n");
		else
      { fprintf (list_fich,
         "Integrals for incommensurate are calculated using %d points%s\n",
          current_modul->order == 0 ? KEY_MODUL_ORDER : -current_modul->order,
          current_modul->order == 0 ? " (default)":"");
			if (current_modul->order == 0) current_modul->order = -KEY_MODUL_ORDER;
		}
   fprintf(list_fich," symetry group : '%s'\n", name);
   current_modul->symgrp = get_sym (name);
   tst_abort ( (current_modul->symgrp->holoedre != current_modul->size),
      " Size of complentary group for modulation does not agree with modulation size");
   tst_abort ( (current_modul->symgrp->nops != l_phase->symgrp->nops),
      " nOps of complentary group for modulation does not agree with basic group");
   if (current_modul->compo_atom )
   {  if ( *compo_symgrp == 0) strcpy(compo_symgrp,"SWAP_COMPO");
	   current_modul->compo_sym = get_sym (compo_symgrp);
      fprintf(list_fich," composite: 2nd layer symetry group : '%s'\n", compo_symgrp);
      if (current_modul->compo_sym4 == NULL)
      {  current_modul->compo_sym4 = get_sym (compo_sym4grp);
         fprintf(list_fich," composite: 2nd layer 4D symetry group : '%s'\n", compo_sym4grp);
         tst_abort ( (current_modul->compo_sym4->holoedre != current_modul->size),
        " Size of complentary group for modulation does not agree with modulation size");
         tst_abort ( (current_modul->compo_sym4->nops != current_modul->compo_sym->nops),
        " nOps of complentary group for modulation does not agree with basic group");
         }
      tst_abort ( (current_modul->compo_sym->bravais != l_phase->symgrp->bravais),
        " XND limitation, use the same lattice by adding necessary translations in composite");
      }  
   tst_abort((l_phase->nb_sets<=0), "@CRYSTAL::SETS!=0 is requested");



	pop_err_msg();
   return current_modul;
   }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */
void fget_crystal (P_(int)nb_hkl)
#ifdef NO_PROTO
int nb_hkl;
#endif
{  float  *p_bond;
   int    i,j,ii,nb0;
   char   nom[NAME_LG];

   push_err_msg("fget_crystal(xnd_rcry.c)");
	current_modul = NULL;
   strcpy(nom, "P1");
   if ( get_keys("CRYSTAL", NULL,
	    "SYMGRP",  KEYTYPE_CHAR,  nom  , nom,  
	    "ATOM",  KEYTYPE_INT,  &l_phase->n_atom  , (int) KEY_CRYST_ATOM,  
	    "ORIEN", KEYTYPE_INT,  &l_phase->n_orien , (int) 0,
	    "PROF",  KEYTYPE_INT,  &l_phase->n_prof  , (int) 0,  
	    "BLOCK", KEYTYPE_INT,  &l_phase->nb_bloc , (int) 0,  
	    "BOND",  KEYTYPE_INT,  &l_phase->nb_bond , (int) 0,  
	    "UNCOH", KEYTYPE_INT,  &l_phase->uncoherent, (int) 0,  
	    "SETS",  KEYTYPE_INT,  &l_phase->nb_sets,  (int) 0,  
	     NULL ) == -1 )
   {  fscanf (coord_fich," %s",nom);
	   fscanf (coord_fich,"%d%d%d%d%d%d",&l_phase->n_orien, &l_phase->n_prof,
         &l_phase->n_atom, &l_phase->nb_bloc, 
         &l_phase->uncoherent, &l_phase->nb_bond);
			}
    fprintf (list_fich," Symmetry group : '%s'\n  %d Polynome(s) en orientation, %d en profil,\n\
  %d atom(s), %d rigid body,\n  %d uncoherent code,  %d T restraints\n\n",
        nom, l_phase->n_orien, l_phase->n_prof, l_phase->n_atom,
        l_phase->nb_bloc, l_phase->uncoherent, l_phase->nb_bond);
    if ( l_phase->nb_sets )
      fprintf (list_fich," nb_sets : %d\n", l_phase->nb_sets);
  l_phase->symgrp = get_sym (nom);
  if (l_phase->n_orien > 0 && n_exper > 1)
      fprintf (list_fich," n_orien > 0 : prefered orientation function is common to all experiment!\n");
  if (l_phase->n_orien < 0 && n_exper > 1)
      fprintf (list_fich," n_orien < 0 : prefered orientation function depend of the experiment!\n %d * %d functions have to be read\n",
          -l_phase->n_orien, n_exper);
      if (l_phase->n_orien >= 0)
      {   l_phase->nt_orien = l_phase->n_orien;
          }
      else
      { l_phase->n_orien *=-1;
        l_phase->nt_orien = l_phase->n_orien * n_exper;
        }
	 l_phase->m_prof = (l_phase->n_prof>=0) ? 0 : - l_phase->n_prof;
	 if (l_phase->m_prof) fprintf (list_fich," n_prof < 0 : profile function depend on the lines set!\n");

    if ( l_phase->uncoherent )
         fprintf (list_fich," uncoherent code implies : %s%s%s\n",
            l_phase->uncoherent & DIF_COMPTON ? " compton":"",
          l_phase->uncoherent & DIF_TDS_HKL ? " tds_hkl":"",
          l_phase->uncoherent & DIF_TDS_000 ? " tds_000":"");

    l_phase->hkl_size = 3;
    fflush (list_fich);
    l_phase->cell=fget_var(CELL,0, VAR_STD,"CELL", (void *)txt_cell, NULL, NULL, 0, 0);

    if (l_phase->nature == PHASE_MAGNET || l_phase->nature == PHASE_MAGMOD )
      l_phase->magnet = fget_magnet();
    if (l_phase->nature == PHASE_MODUL || l_phase->nature == PHASE_MAGMOD )
      l_phase->modul = fget_modul();
    if  (l_phase->nb_sets != 0)
	 { int result;
		l_phase->sets =  sets_fget( NULL, l_phase->nb_sets, &result);
	   tst_abort((result < l_phase->nb_sets ),
			" %d != %d key(s) @SET_x are requested for multisets phases or rules evaluation",
         result, l_phase->nb_sets);
		if ( l_phase->nb_sets > 1) tot_phase += l_phase->nb_sets - 1;
		} else
      l_phase->sets =  sets_make( NULL, 1, nb_hkl) ;

    fget_vector();
    fget_phase_orien();
    fget_phase_prof();
                
    fflush (list_fich);
    nb0 = n_par;
    lect->n_magnet = lect->n_modul  = lect->sites = 0;
    current_symgrp = l_phase->symgrp;
    l_phase->atom = fget_atom (l_phase->n_atom, 0);
    l_phase->nb_atom = l_phase->n_atom;
    if (l_phase->nb_bloc != 0)
    {   l_phase->bloc=fget_var(BCOOR*l_phase->nb_bloc,BCOOR, VAR_ORIEN,
            T_BLOC, (void *)txt_bloc, NULL, NULL, 0, 0);
        l_phase->bl_atom = (int *) tst_alloc (l_phase->nb_bloc,
        sizeof(int),"bloc");
        l_phase->bl_ortho = (TYPE_ATOM **) tst_alloc (l_phase->nb_bloc,
        sizeof(TYPE_ATOM *),"bloc");
        l_phase->bl_relat = (TYPE_ATOM **) tst_alloc (l_phase->nb_bloc,
        sizeof(TYPE_ATOM *),"bloc");
        for (j=0;j<l_phase->nb_bloc;j++)
        {  fscanf(coord_fich,"%d",&l_phase->bl_atom[j]);
           fprintf(list_fich," The rigid body klock #%d_ is made with %d atoms\n",
            j,l_phase->bl_atom[j]);
           tst_abort ((l_phase->bl_atom[j]==0),"BLOC vide");
           l_phase->nb_atom += l_phase->bl_atom[j];
           l_phase->bl_ortho[j] = fget_atom (l_phase->bl_atom[j], 1);
        }   }
    if (n_par == nb0) l_phase->nb_par = 0;
    fprintf(list_fich," The unit cell contains %d sites\n", lect->sites);
    if (!l_phase->magnet && lect->n_magnet) fprintf (list_fich,
       " magnetic atoms are skipped: phase is not known as magnetic!\n");
    if (!l_phase->modul && lect->n_modul) fprintf (list_fich,
       " modulated atoms are skipped: phase is not known as modulated!\n");

    if (l_phase->modul && current_modul->big_cell  && current_modul->compo_atom )
    {  float z_wave;
	    var_init(l_phase->vector);
       z_wave = var_valeur(2);
       j = 0.5 + z_wave * current_modul->big_cell;
       /* coordinates in a superstructure approximation */
       fprintf(list_fich, "\n Big cell approximation of composite structure : %dc and %dc (%d*%.2f)\n",
         current_modul->big_cell, j, current_modul->big_cell, z_wave);
       for (ii=0; ii<l_phase->n_atom; ii++)
       {  l_atom = l_phase->atom + ii;
          if ( ii < current_modul->compo_atom ) big_cell(current_modul->big_cell, l_phase->symgrp, current_modul->symgrp );
	       else   big_cell(j, current_modul->compo_sym, current_modul->compo_sym4 );
 	    }  }

	 for (ii=0, current_sets=l_phase->sets; (ii==0)||(ii<l_phase->nb_sets); ii++,current_sets++)
	 {   if (current_sets->nb_hkl) current_sets->intensity =
         fget_var(current_sets->nb_hkl, 0, VAR_HKL, "LINES", NULL, NULL, NULL, VAR_MODE_GT0, 0);
        if ( l_phase->nb_atom == 0 &&
           (current_sets->intensity == NULL || current_sets->intensity->order == 0)) fprintf(list_fich,
          " There is ZERO atom in the cell, assuming Fhkl = 1 for all lines of SET_%d\n", ii);
        }
    if (l_phase->uncoherent)
    {   l_phase->tds=fget_var (TDS, 0, VAR_STD, "DIFFUSE",
	       ( void * ) txt_tds, NULL, NULL, 0, 0);
        }    
    tst_abort(((l_phase->n_atom==0) &&
        (l_phase->nb_bond || l_phase->nb_angl)),
         " Usage contrainte invalide");
    if (l_phase->nb_bond)
    {    l_phase->remark_bond = read_remark(NULL);
        p_bond = l_phase->bond = (float *) tst_alloc(l_phase->nb_bond,
            sizeof(FLOAT),"bond");
        fscanf (coord_fich,"%d%d",&l_phase->nb_dist,&l_phase->nb_angl);
        fprintf (list_fich,"\n %d distance(s) %d angle(s)\n",
            l_phase->nb_dist,l_phase->nb_angl);
        for (i=0;i<l_phase->nb_bond;i++,p_bond++)
        {    fscanf (coord_fich,"%f",p_bond);
            fprintf (list_fich,"%3d T_bond %f\n",i,*p_bond);
            }
        l_phase->dist = fget_dist (1, l_phase->nb_dist);
        l_phase->angl = fget_dist (2, l_phase->nb_angl);
        }

    pop_err_msg();
    }
/* ------------------------------------------------------------------ */
/* ------------------------------------------------------------------ */


