static char *cvs_id =" $Id: xnd_sym.c,v 1.2 2002/01/10 15:24:45 berar Exp $ ";
/* XND_SYM.C multiplicite, holoedre, extinction */

#define  USE_BRAGG
/*#define  USE_VAR  */
#define  USE_SYM
#include "../xnd_def.h"
TYPE_SYMGRP * current_symgrp;
/* ---------------------------------------------------------- */
/* the following functions can be redirected in case of       */
/* modulated phases, for composite 0,0,0,m may exists         */
/* ---------------------------------------------------------- */
/*  std_multiplicity according  TIC  (old tables  I p32 )     */
int C_multiplicity (P_(void))    /* cubic groups */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(6);
     if ( H==0 || K==0 || L==0)
     {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return (12);
        if (current_symgrp->holoedre) return (24);
        return(12);
        }
     if ( H==K && K==L) return (8);
     {  if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return (24);
        if (current_symgrp->holoedre) return (48);
        return(24);
        }
     }   
int Q_multiplicity (P_(void))   /* quadratic (tetragonal) groups */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if (H==0 && K==0) return (2);
     if (L==0)
     {   if ( H==0 || K==0 || H==K || H+K==0) return (4);
         if (current_symgrp->holoedre) return (8);
         return (4);
         }
     if ( H==0 || K==0 || H==K || H+K==0) return (8);
     if (current_symgrp->holoedre) return (16);
     return (8);
     }   
int H_multiplicity (P_(void))   /* hexagonal (Laue classes 6/m and 6/mmm) */ 
{   if ( H==0 && K==0 && L==0 ) return(1);
     if (H==0 && K==0) return (2);
    if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0)
    {    if (L==0) return (6);
         return (12);
         }
    if (L==0)
    {   if (current_symgrp->holoedre) return(12);
        return (6);
        }
    if (current_symgrp->holoedre) return(24);
        return (12);
     }   
int R_multiplicity (P_(void))    /* trigonal with Hexagonal axes */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if (H==0 && K==0) return (2);
     if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0)
      /* -3M1 */       return(6);
     if (current_symgrp->holoedre) return(12);
     return (6);
     }   
int T_multiplicity (P_(void))  /* trigonal with rhomboedral axes */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if ( H==K && K==L) return(2);
     if (H==K || K==L || L==H) return(6);
     if (H+K==0 || K+L==0 || L+H==0)
     {  if ((H + K + L != 0) && current_symgrp->holoedre) return (12);
        return(6);
        }
     if (current_symgrp->holoedre) return (12);
     return(6);
     }   
int O_multiplicity (P_(void))  /* orthorhombic */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
     if ( H==0 || K==0 || L==0) return(4);
     return(8);
     }   
int M_multiplicity (P_(void))  /* monoclinic  B */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
     if ( K==0 ) return(2);
     return(4);
     }   
int N_multiplicity (P_(void))  /* monoclinic  C */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
     if ( L==0 ) return(2);
     return(4);
     }   
int L_multiplicity (P_(void))  /* monoclinic  A */
{    if ( H==0 && K==0 && L==0 ) return(1);
     if ( (H==0 && K==0) || (K==0 && L==0) || (L==0 && H==0)) return(2);
     if ( H==0 ) return(2);
     return(4);
     }   
int A_multiplicity (P_(void))  /* triclinic or anortic */
{    if ( H==0 && K==0 && L==0 ) return(1);
     return (2);
     }
int dummy_multiplicity (P_(void))  
{    return (1);
     }
/* ---------------------------------------------------------- */
/* std_gen_holoedre used in case of not holoedric group       */
void C_gen_holoedre (P_(void))     /* cubic */
{   short ho, ko;
    if ( (H==0 && K==0) || (K==0 && L==0)|| (L==0 && H==0))    return;
    if ( H==0 || K==0 || L==0)
    {   if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0) return;
        }
    else
    {   if ( H==K && K==L) return;
        if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return;
        }
    ho = H; ko = K;
    H = ko; K = ho; 
    exist_hkl (0);
    H = ho; K = ko;
    }
void Q_gen_holoedre (P_(void))
{   short ho, ko;
    ho = H; ko = K;
    if (H==0 && K==0) return;
    if (L==0)
    {   if ( H==0 || K==0 || H==K || H+K==0) return;
        }
    else 
    {   if ( H==0 || K==0 || H==K || H+K==0) return;
        }
    H = ko; K = ho; 
    exist_hkl (0);
    H = ho; K = ko;
    }
void H_gen_holoedre (P_(void))
{   short ho, ko;
    if (H==0 && K==0) return;
    if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0) return;
    ho = H; ko = K;
    H = ko; K = ho;
    exist_hkl (0);
    H = ho; K = ko;
    }
void R_gen_holoedre (P_(void))
{   short ho, ko;
    if (H==0 && K==0) return;
    if ( H==0 || K==0 || H==K || H+K==0 || 2*H+K==0 || H+2*K==0) return;
    ho = H; ko = K;
    H = ko; K = ho;
    exist_hkl (0);
    H = ho; K = ko;
    }
void T_gen_holoedre (P_(void))
{   short ho, ko;
    if ( H==K && K==L) return;
    if ( H+K+L==0 )
    {   if (H==K || H+K==0 || K==L || K+L==0 || L==H || L+H==0)  return;
        }
    else
    {   if (H==K || K==L || L==H)  return;
        }
    ho = H; ko = K; 
    H = ko; K = ho;  
    exist_hkl (0);
    H = ho; K = ko;
    }
void dummy_gen_holoedre (P_(void))
{   return;
    }
/* ---------------------------------------------------------- */
/* allowed hkl lines return 0, others 1 */
int A_extinction (P_(void))
{   return ((K+L)%2);
    }
int B_extinction (P_(void))
{   return ((L+H)%2);
    }
int C_extinction (P_(void))
{   return ((H+K)%2);
    }
int I_extinction (P_(void))
{   return ((H+K+L)%2);
    }
int F_extinction (P_(void))
{   if ((abs(H)%2 == abs(K)%2) && (abs(K)%2 == abs(L)%2) ) return 0;
    return 1;
    }
int S_extinction (P_(void))
{   return ((K-H+L)%3);
    }
int R_extinction (P_(void))
{   return ((H-K+L)%3);
    }
int H_extinction (P_(void))
{   return ((H-K)%3);
    }
int P_extinction (P_(void))
{   return (0);
    }
/* -------------------------------------------- */
/*    init called by pseudophase initialisation */
/* -------------------------------------------- */
int ini_3D_fhkl_mult(P_(TYPE_SYMGRP *) symgrp)
{  int bravais = symgrp->bravais;
   int fhkl_mult = symgrp->centro ? 2 : 1;
   if ( bravais=='A'|| bravais=='B'|| bravais=='C'|| bravais=='I')
        return 2*fhkl_mult;
	if ( bravais=='R'|| bravais=='S')  return 3*fhkl_mult;
	if ( bravais=='F') return 4*fhkl_mult;
   return fhkl_mult;
   }
/* -------------------------------------------- */
/* this seems not allowed : *ext=ini_3D_ext(s)  */
/* but works using void *  as function type     */       
/* -------------------------------------------- */
void * ini_3D_extinction (TYPE_SYMGRP *symgrp  )
{  switch (symgrp->bravais)
   {  case 'A' : return (void *) A_extinction;
      case 'B' : return (void *) B_extinction;
      case 'C' : return (void *) C_extinction;
      case 'I' : return (void *) I_extinction;
      case 'F' : return (void *) F_extinction;
      case 'R' : return (void *) R_extinction;
      case 'S' : return (void *) S_extinction;
      case 'H' : return (void *) H_extinction;
      case 'P' : return (void *) P_extinction;
      }
    tst_abort(1," Unexpected case in ini_extinction xnd_sym.c)");
    return NULL;
   }
/* -------------------------------------------- */
void * ini_3D_multiplicity (TYPE_SYMGRP *symgrp )
{  switch (symgrp->systeme)
   {  case 'C' : return (void *) C_multiplicity; 
      case 'Q' : return (void *) Q_multiplicity;  
      case 'H' : return (void *) H_multiplicity;   
      case 'R' : return (void *) R_multiplicity;    
      case 'T' : return (void *) T_multiplicity;    
      case 'O' : return (void *) O_multiplicity;
      case 'M' : return (void *) M_multiplicity;
      case 'N' : return (void *) N_multiplicity;
      case 'L' : return (void *) L_multiplicity;
      case 'A' : return (void *) A_multiplicity;
      }
    return (void *) dummy_multiplicity ;
   }
/* -------------------------------------------- */
void * ini_3D_gen_holoedre (TYPE_SYMGRP *symgrp )
{  switch (symgrp->systeme)
   {  case 'C' : return (void *)  C_gen_holoedre;
      case 'Q' : return (void *)  Q_gen_holoedre;
      case 'H' : return (void *)  H_gen_holoedre;
      case 'R' : return (void *)  R_gen_holoedre;
      case 'T' : return (void *)  T_gen_holoedre;
      }
    return (void *) dummy_gen_holoedre;;
   }
/* -------------------------------------------- */
/* -------------------------------------------- */
/* -------------------------------------------- */

