static char *cvs_id =" $Id: xnd_loop.c,v 1.2 2002/05/02 12:43:27 berar Exp $ ";
/* xnd_loop.c  the experiment main loop  */

#define USE_RPRO
#define USE_RBRG
#define USE_BRAGG
#define USE_VAR
#define USE_SCAN
#define USE_EXPER
#define USE_ATOM
#define USE_SETS
#define USE_PHASE
#define USE_PSEUDO
#define USE_VAR

#include "xnd_def.h"
#include "xnd_cah.h"
#include "xnd_snh.h"
#include "xnd_mem.h"

#include <string.h>


#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h> 
#endif
/* ------------------------------------------------------------------ */
TYPE_EXPER  *exper;
TYPE_EXPER  *l_exper;
TYPE_SCAN   *l_diag;
/* ------------------------------------------------------------------ */
extern TYPE_RPRO indic;                 /* overall sums */
extern FLOAT t_pen, t_sng, t_eff;
extern int n_tot, nt_par;
#if defined ( __STDC__ ) || defined ( MAC_OS )
extern time_t secs_now;
#else
extern long  secs_now;
#endif
/* ------------------------------------------------------------------ */
int  powder PROTO(( void));
/* ------------------------------------------------------------------ */
void exper_loop (P_(void))
{   int i,j,n_p;
    FLOAT val;

    push_err_msg("exper_loop(xnd_loop.c)");
    time (&secs_now);
    str_time = ctime(&secs_now);
    verbose_printf ("%s #%d CYCLE #%d #%d %s %s",minli==0?"\n":"",
         prt_new, cycle, minli, host, str_time);
    memset (&indic,0,sizeof(TYPE_RPRO));
    n_tot = t_pen = t_sng = t_eff = 0;
    data_start();  /* rewind (data_fich); */
    if (hkldata_fich) rewind (hkldata_fich);
    do_derivatives = (fini == 0 && minli == 0);
    do_plg_data = (fini == 1 && minli == 0) && prt_plg;
    for (i=0,l_exper=exper;i<n_exper;i++,l_exper++)
    {       
    push_err_msg(l_exper->nom);
    l_reglage =  l_exper->reglage;
    l_instru = l_exper->instru;
    l_asym = l_exper->asym;
    l_onde = l_exper->onde;
    dif_nature = l_exper->nature;
    if ((dif_nature & EXPER_N)  != 0)         valdif = b_valdif;
    else if ((dif_nature & EXPER_RX) != 0 )   valdif = x_valdif;
    else chk_abort ("dif_nature invalide");
    j = l_exper->prof_par + phase_prof_par;
    if (j)
    {   prof_mat = (float *) tst_alloc((j*(j+1))/2,sizeof(float),"prof_mat");
        prof_pos = (int *) tst_alloc(n_par,sizeof(int),"prof_pos");
        }
    else
    {   prof_mat = NULL;
        prof_pos = NULL;
        }
    for (j=0,l_diag=l_exper->diag;j<l_exper->n_diag;j++,l_diag++)
    {   if (l_diag->indic == NULL) l_diag->indic = tst_alloc(1, sizeof(TYPE_RPRO),"diag_rpro");
	     l_indic = l_diag->indic;
        memset (l_indic, 0, sizeof(TYPE_RPRO));
        if ((l_exper->nature & EXPER_SINGLE_CRYSTAL)==0) 
        {    n_tot +=powder ();
             indic.sd_wp += l_indic->sd_wp;
             indic.so_wp += l_indic->so_wp;
             indic.sd_p += l_indic->sd_p;
             indic.so_p += l_indic->so_p;
             indic.sd_wp_cor += l_indic->sd_wp_cor;
             indic.s_n +=l_indic->s_n;
             indic.d_val +=l_indic->d_val;
             indic.sd_wp_b += l_indic->sd_wp_b;
             indic.so_wp_b += l_indic->so_wp_b;
             indic.sd_p_b += l_indic->sd_p_b;
             indic.so_p_b += l_indic->so_p_b;
             indic.s_n_b +=l_indic->s_n_b;
             }
        else  n_tot += sng_crystal(&t_sng) ;
        }
     if (prof_pos!=NULL) free (prof_pos);
     if (prof_mat!=NULL) free (prof_mat);
     pop_err_msg();
     }

     for (i=0,l_phase=phase;i<n_phase;i++,l_phase++)
        if (l_phase->nature>=0 && l_phase->nb_bond) t_pen += penal ();
     
     fprt_indic (&indic, 1);
     t_eff = t_pen + t_sng;
     if (mod_lsq & 4) t_eff += indic.sd_wp_cor;
     else if (mod_lsq & 8) t_eff += indic.sd_wp_b;
     else t_eff += indic.sd_wp;
     n_p = n_tot - nt_par;
     if (t_eff>EPSILON)
     {   verbose_printf (" Minimised_Sum =  %.7g", t_eff);
         if ( t_pen + t_sng > 0 )
            verbose_printf (" (powder = %.7g, penal = %.7g, hkl = %.7g)", t_eff-t_pen-t_sng, t_pen, t_sng);
         verbose_printf ("\n");
        if (minli==0)
        {   val_sigma = t_eff / n_p;
            val = sqrt ((t_pen+indic.sd_wp_cor)/t_eff);
            fprintf (list_fich,
                "\n Probable errors on variables = %.2f * sigma\n", val);
            val = 3.0/sqrt(1.0*n_p);
            if (n_p > 100)  fprintf (list_fich, 
                " Statisticaly, the model may be accepted if : \n\
   |GoF-1|, |d-2| <~ 3/sqrt(%d)= %.4f\n", n_p, val);
           }   
    }
    fflush (list_fich);
/*    dump_err_msg(); */
    pop_err_msg();
    }

/* ------------------------------------------------------------------ */
int powder (P_(void))
{   int    i;
    int    iphase;

    push_err_msg("powder(xnd_main.c)");
    dim_bragg = 0;
    temp_exper = l_diag->temp-l_exper->temp_orig;
    temp = &temp_exper;
    minimum = l_diag->w_mini * eps_prof;
    diag_p0 = l_diag->dtheta0;
    diag_pn = l_diag->dthetaf;
    var_init (l_reglage);
    zero   = var_valeur (0);
    polar  = var_valeur (1);
    tan_tm = var_valeur (2);
    eclair = var_valeur (3);
    i_eclair = eclair > EPSILON;

 /*   if (fini && minli==0) */
    {   bragg_fich =  tmpfile ();
        if (bragg_fich==NULL)
        fprintf (list_fich," R_BRAGG not calculated, impossible to allocate the needed temporary file\n");
        }

    if (minli==0 && (n_exper>1 || nt_diag>1))
       verbose_printf (" EXPER '%s' at %.3f\n", l_exper->nom, l_diag->temp);
        
    memory_new(n_par, tot_phase);
    (*back_ground) ();

    for (iphase=0,l_pseudo_phase=pseudo_phase;
            iphase<tot_phase; iphase++,l_pseudo_phase++)
    {   l_phase = l_pseudo_phase->phase;
        push_err_msg(l_phase->nom);
        temp_phase = l_diag->temp-l_phase->temp_orig;
        temp = &temp_phase;
        
        if (minli==0 )
        {   fprintf (list_fich," PHASE #%d : '%s' %s\n", act->phase, 
                     l_phase->nom, l_pseudo_phase->txt);
            }
        m_bragg = n_bragg = t_bragg= 0;
        if ( l_phase->nature == PHASE_PARASITE || 
		       l_phase->nature == PHASE_RADIAL || 
		       l_phase->nature == PHASE_AMORPHE || ini_metric() > 0)
        {   d_echelle = (float *) tst_alloc
               (l_phase->ech->dim+l_phase->transit->dim,sizeof(FLOAT),"scale");
            var_init(l_phase->ech);
            phase_echelle = var_valeur (0);
            bg = var_valeur (1);
            *d_echelle = 1 / phase_echelle;
            for (i=0;i<l_phase->transit->dim;i+=TRANSIT)
                 phase_echelle *= f_echelle(i, d_echelle);
            if (n_phase>1 && minli==0)
                 fprintf (list_fich,"  E=%8.3g (%5.3f)",
                     phase_echelle, phase_echelle* *d_echelle);
            if (phase_echelle > EPSILON)
            {   l_atom = l_phase->atom;
                if (l_phase->nature == PHASE_AMORPHE) int_amorphe (); 
                else
                if (l_phase->nature == PHASE_RADIAL) int_radist (); 
                else
                {  make_hkl(iphase);
                   dim_bragg += m_bragg;
                   }
                }
            else fprintf (list_fich," Meaningless scale factor\n");
            free (d_echelle);
            }
        else fprintf (list_fich," Cell volume of this phase is non-positive\n");
        fflush(list_fich);
        if (l_pseudo_phase->ps_case == PS_STD)
        {   if (l_phase->uncoherent & DIF_COMPTON )   gen_uncoherent();
            if (l_phase->uncoherent & DIF_TDS_000 )   gen_tds_0();
            }
        pop_err_msg();
        } /* for iphase */
    temp = &temp_exper;
    residu();
    if (minli == 0 && bragg_fich!=NULL)
    {   if (fini) brg_file(); else brg_residual();
        bragg_fich=xclose(bragg_fich);
        }
   memory_free();
    fflush(list_fich);
    pop_err_msg();
    return (n_pts);
    }
/* ---------------------------------------------------------- */
/* ---------------------------------------------------------- */


