/* $Id: xnd_mem.h,v 1.1.1.1 2000/00/04 15:06:00 berar Exp $ */
/* xnd_mem.h    data storage */
/* --------------------------------------------- */
#ifndef  XND_MEM_H_INCLUDED  /* included once only */
#define  XND_MEM_H_INCLUDED
/* ---------------------------------------------- */
/*   in XND_SWAP.C */
/* macros and routines allowing the derivative table dy_dp to be stored on disk */
/* parameters start at 1 */
#define DYDP_IOBS 0
#define DYDP_WGTH 1
#define DYDP_ICAL 2
#define DYDP_IBKG 3
#define DYDP_IDER 3
#define DYDP_IPHA 4

#define get_iobs(p)        (*get_dydp_val)(p, DYDP_IOBS)
#define get_wght(p)        (*get_dydp_val)(p, DYDP_WGTH)
#define get_ical(p)        (*get_dydp_val)(p, DYDP_ICAL)
#define get_ibkg(p)        (*get_dydp_val)(p, DYDP_IBKG)
#define get_dydp(p,d)      (*get_dydp_val)(p, DYDP_IDER+d)
#define get_ipha(p,n)      (*get_dydp_val)(p, DYDP_IPHA+n)

#define put_iobs(p,v)      (*set_dydp_val)(p, DYDP_IOBS, v)
#define put_wght(p,v)      (*set_dydp_val)(p, DYDP_WGTH, v)
#define put_ical(p,v)      (*set_dydp_val)(p, DYDP_ICAL, v)
#define put_ibkg(p,v)      (*set_dydp_val)(p, DYDP_IBKG, v)

#define add_ical(p,v)      (*add_dydp_val)(p, DYDP_ICAL, v)
#define add_ibkg(p,v)      (*add_dydp_val)(p, DYDP_IBKG, v)
#define add_dydp(p,d,v)    (*add_dydp_val)(p, DYDP_IDER+d, v)
#define add_ipha(p,n,v)    (*add_dydp_val)(p, DYDP_IPHA+n, v)

/*#define put_iobs(pts)        dy_dp[pos_dydp(1,pts,0)]
#define get_wght(pts)        (*get_dydp_val)(pts,DYDP_IOBS)dy_dp[pos_dydp(0,pts,1)]
#define put_wght(pts)        dy_dp[pos_dydp(1,pts,1)]
#define get_ical(pts)        (*get_dydp_val)(pts,DYDP_IOBS)dy_dp[pos_dydp(0,pts,2)]
#define put_ical(pts)        (*get_dydp_val)(pts,DYDP_IOBS)dy_dp[pos_dydp(1,pts,2)]
#define get_back(pts)        dy_dp[pos_dydp(0,pts,3)]
#define put_back(pts)        (*get_dydp_val)(pts,DYDP_IOBS)dy_dp[pos_dydp(1,pts,3)]
#define get_dydp(pts,par)    pos_dydp(0,pts,(DYDP_NB-1)+par)
#define put_dydp(pts,par)    pos_dydp(1,pts,(DYDP_NB-1)+par)
*/
int  pos_dydp   PROTO((unsigned cas, unsigned pts, unsigned par));

long memory_swap PROTO((int max_points, int n_par, int disk_dydp));
void memory_adjust(int n_par);
void memory_new  PROTO((int n_par, int tot_phase)); 
void memory_free PROTO((void)); 
void memory_file (FILE * tmp);
void memory_close (void);
extern FLOAT (* get_dydp_val)(unsigned pts, unsigned pos);
extern void  (* set_dydp_val)(unsigned pts, unsigned pos, FLOAT f);
extern void  (* add_dydp_val)(unsigned pts, unsigned pos, FLOAT f);
/* --------------------------------------------- */
void data_read (OBS_PTR obs);
void data_write (OBS_PTR obs);
void data_init( FILE * f, int file_mode);
void data_start( void );
void data_close( void );
/* --------------------------------------------- */
#endif          /*  XND_MEM_H_INCLUDED       */
/* --------------------------------------------- */
