static char *cvs_id =" $Id: xnd_mini.c,v 1.1.1.1 2000/05/28 13:14:00 berar Exp $ ";
/* xnd_mini.c     linear minimisation and related */

#define USE_RPRO
#define USE_RBRG
#define USE_BRAGG
#define USE_VAR
#define USE_SCAN
#define USE_EXPER
#define USE_ATOM
#define USE_SETS
#define USE_PHASE
#define USE_PSEUDO
#define USE_VAR

#include "xnd_def.h"
#include "xnd_cah.h"
#include "xnd_snh.h"
#include "xnd_mem.h"

#include <string.h>

#ifndef _INCLUDE_HPUX_SOURCE
#include <time.h> 
#endif

extern FLOAT t_pen, t_sng, t_eff;
#if defined ( __STDC__ ) || defined ( MAC_OS )
extern time_t secs_now;
extern clock_t clock_min, clock_now;
#else
extern long  secs_now;
extern long clock_min, clock_now;
#endif
/* ------------------------------------------------------------------ */
/*  this subroutine tries to find the best fit along the direction    */
/*  defined by the vector y_vect : it calculates the residu, compares */
/*  it with previous values and amplifies the dispacement             */
void min_lin ()
{  int  i, t_par, n_parab;
   FLOAT shift, deplace, ot_eff, t_min, t_max;
   FLOAT position, n_pos, pos_max, pos_min;
   FLOAT delta, a ,b, x[3], x2[3], y[3], parab;
   char *motif;

   push_err_msg("min_lin(xnd_main.c)");
   clock_now=clock();
   opt_deplace = parab = 0; 
	ot_eff = t_eff;
   pos_min = -1000;
	pos_max = 1000;
	position = shift = deplace = relax;
   t_par = n_par;
   n_par = n_parab = 0;
   shift_e = (float *) tst_alloc(t_par, sizeof(float),"vector");
   motif = "lsq";
          
   for (i=0; i<t_par; i++)
   {  shift_e[i] = y_vect[i];
	   y_vect[i] *= relax;
      }
   for (minli=1; minli<12; minli++)
   {  fprintf(list_fich,"\n  Position %.3f (%s)", position, motif);
      if (pos_min > -900) fprintf(list_fich,", min %.3f (%.1f)", pos_min, t_min);
      if (minli > 1) fprintf(list_fich,", opt %.3f (%.1f)", opt_deplace, ot_eff);
      if (pos_max <  900) fprintf(list_fich,", max %.3f (%.1f)", pos_max, t_max);
      fprintf(list_fich,"\n");
	   imprime (0, 0, ( minli==1) );
      if ((fini && (minli > 4)) || (fabs(shift) < 0.002*relax)|| (fabs(deplace) < 0.01*relax)) break;
      exper_loop ();

      if (minli >= 2 )
      {  x[1] = opt_deplace;
         x2[1]= opt_deplace * opt_deplace;
         y[1] = ot_eff;
         x[2] = position;
         x2[2]= position * position;
         y[2] = t_eff;
         if ( (position  - pos_min) < (pos_max - position))
			{  x[0] = pos_min; x2[0] = pos_min * pos_min; y[0] = t_min;
            motif = "quad min"; 
				}
         else
			{  x[0] = pos_max; x2[0] = pos_max * pos_max; y[0] = t_max;
            motif = "quad max"; 
				}
         delta = x2[0]*(x[1]-x[2])+x2[1]*(x[2]-x[0])+x2[2]*(x[0]-x[1]);
         a = y[0]*(x[1]-x[2])+y[1]*(x[2]-x[0])+y[2]*(x[0]-x[1]);
         b = x2[0]*(y[1]-y[2])+x2[1]*(y[2]-y[0])+x2[2]*(y[0]-y[1]);
         if (a * delta > EPSILON)
         {  parab = -0.5 * b / a;
            n_parab++;
            } else n_parab = 0;
/*verbose_printf(" minli A %d parab %.3g n_parab %d\n", minli, parab, n_parab); */
         }  /* minli >= 2 */
      if (t_eff < ot_eff)
      {  if (shift > 0) { pos_min = opt_deplace; t_min = ot_eff; }
         else           { pos_max = opt_deplace; t_max = ot_eff; }
         if (minli > 1) shift *= 2;
         opt_deplace = position;
         ot_eff = t_eff;
         }
      else
      {  if (shift > 0 ) { pos_max = position; t_max = t_eff; }
			else            { pos_min = position; t_min = t_eff; }
         shift *= -0.5;
         }
/*verbose_printf(" minli B %d opt_deplace %.2f shift %.3g lin %.3g\n",
  minli, opt_deplace, shift, opt_deplace+shift); */
      if (shift >  0.5 * (pos_max - opt_deplace) && pos_max < 900)
          shift = 0.5 * (pos_max - opt_deplace);
      else if (shift < 0.5* (pos_min - opt_deplace) && pos_min > -900)
          shift = 0.5 * (pos_min - opt_deplace);
      n_pos = opt_deplace + shift;

/*verbose_printf(" minli C %d n_pos %.3f p_min %.2f p_max %.2f\n",
  minli, n_pos, pos_min, pos_max); */

      if (n_parab  && (( fabs((parab - n_pos) / shift) < 5) ||
         ( parab < pos_max) && (parab > pos_min)))
      {    deplace = parab /* - position */;
           position = parab;
           shift = position - opt_deplace;
           }
      else
      {    deplace =  n_pos /* - position */;
           position = n_pos;
           motif = "lin.";
           }
      for (i=0;i<t_par;i++)
      y_vect[i] = shift_e[i] * deplace;
      xt_eff = t_eff;
      }
   if (fabs(opt_deplace) < 0.01*relax) opt_deplace = position;
   fprintf(list_fich,"\n  Shifts at %.3f, ending position\n", opt_deplace);
   for (i=0;i<t_par;i++) y_vect[i] = shift_e[i] * opt_deplace;
/*   if (fabs(opt_deplace) > 0.01*relax) opt_deplace = -position / opt_deplace;
*/   free (shift_e);
   minli = -1;
   n_par = t_par;
   t_eff = ot_eff;
   clock_min+=clock()-clock_now;
   pop_err_msg();
   }

/* ------------------------------------------------------------------ */
/* this routine tries to keep trace of the refinement history for future */
/* ------------------------------------------------------------------ */
static float **y_history;
static float  *norm_history = NULL;
void history (P_(void))
{	int i;
   if (cycle == 0)
   {  y_history = (float **) tst_alloc(max_cycle+1, sizeof(float*),"history");
      norm_history = (float *) tst_alloc(n_par, sizeof(float),"history");
      for (i=0; i<max_cycle+1; i++) 
      y_history[i] = (float *) tst_alloc(n_par, sizeof(float),"history");
      }
    norm_history[cycle]=0;
    for (i=0; i<n_par; i++) norm_history[cycle]+=y_vect[i]*y_vect[i];
    norm_history[cycle]=sqrt(norm_history[cycle]);
    for (i=0; i<n_par; i++) y_history[cycle][i] = y_vect[i]/norm_history[cycle];
     if (cycle != 0)
     {  int j;
	     float proj;
        fprintf(list_fich,"\n Angle and projection of calculated motion on previous motions :\n");
        for (j=0; j < cycle; j++)
        {   proj=0;
            for (i=0; i<n_par; i++) proj+=y_history[j][i]*y_vect[i];
            fprintf(list_fich," [%d] %6.1f %g\n", j, acos(proj/norm_history[cycle]) / RAD, proj);
            }
         fprintf(list_fich,"\n");
         }
   }
/* ---------------------------------------------------------- */
void resize_history (P_(int) n_par0)
{	int i;
   if (n_par0)
	{  y_vect = (FLOAT *) realloc(y_vect, n_par*sizeof(FLOAT));
		matrice =(FLOAT *) realloc(matrice, n_mat*sizeof(FLOAT));
		norm_history =(float *) realloc(norm_history, n_par*sizeof(float));
      for (i=0; i<max_cycle+1; i++) 
         y_history[i] = (float *) realloc( y_history[i], n_par*sizeof(float));
		} else
	{  y_vect = (FLOAT *) malloc(n_par*sizeof(FLOAT));
		matrice =(FLOAT *) malloc(n_mat*sizeof(FLOAT));
		norm_history =(float *) malloc(n_par*sizeof(float));
      y_history = (float **) malloc(max_cycle+1*sizeof(float*));
      for (i=0; i<max_cycle+1; i++) 
          y_history[i] = (float *) malloc(n_par*sizeof(float));
			 }
		tst_abort((y_vect==NULL||matrice==NULL||norm_history==NULL)," resize error");
    }
/* ---------------------------------------------------------- */

